class FPUI.DropdownList extends FPUI.Component
{
    var _visible;
    function DropdownList()
    {
        var _l1 = this;
        super();
        _l1.setListVisible(false);
        _l1.m_rowHeight = Math.max(FPUI.DropdownList.ICON_SIZE + FPUI.DropdownList.ICON_X_PAD * 2, FlashPaper.Utils.UISMALLFONTSIZE + FPUI.DropdownList.TEXT_FIELD_SLOP);
        _l1.m_selectedItem = -1;
        _l1.useHandCursor = false;
        _l1.m_data = new Array();
        _l1.m_dividers = new Array();
        _l1.createEmptyMovieClip("m_highlightMC", -1);
        _l1.adjustHeight();
    } // End of the function
    function setController(controller)
    {
        this.m_controller = controller;
    } // End of the function
    function setCursorManager(cursorManager)
    {
        this.m_cursorManager = cursorManager;
    } // End of the function
    function setButton(button)
    {
        var _l1 = this;
        _l1.m_button = button;
        _l1.m_button._visible = false;
        _l1.m_button.m_eatsNavKeysWhenFocused = true;
        _l1.m_button.setKeyHandler(_l1);
    } // End of the function
    function setListVisible(visible)
    {
        var _l1 = this;
        var _l2 = visible;
        if (_l1._visible == _l2)
        {
        }
        else
        {
            _l1._visible = _l2;
            if (_l2)
            {
                if (_l1.m_button)
                {
                    _l1.m_button.setActive(true);
                    _l1.m_button.pressFocus();
                } // end if
                FlashPaper.Utils.removeShadow(_l1);
                FlashPaper.Utils.addShadow(_l1, 0, _l1.list_mc._width, _l1.list_mc._height, true);
            }
            else
            {
                if (_l1.m_button)
                {
                    _l1.m_button.setActive(false);
                    if (FPUI.Component.focusedComponent == _l1.m_button)
                    {
                        Selection.setFocus(null);
                    } // end if
                } // end if
                _l1.highlightItem(-1);
            } // end if
        } // end if
    } // End of the function
    function onButtonRelease()
    {
        var _l1 = this;
        if (_l1.m_button)
        {
            var _l2 = _l1.m_button.getBounds(_l1._parent);
            _l1._x = Math.round(_l2.xMin - (_l1.list_mc._width - _l1.m_button._width));
            _l1._y = Math.round(_l1._y);
            _l1.setListVisible(!_l1._visible);
        } // end if
    } // End of the function
    function moveSelection(dir)
    {
        var _l2 = this;
        var _l1 = _l2.m_selectedItem;
        _l1 = _l1 + dir;
        if (_l1 >= 0 && _l1 < _l2.m_data.length)
        {
            _l2.highlightItem(_l1);
        } // end if
    } // End of the function
    function addItem(iconName, displayText, method)
    {
        var _l1 = this;
        var _l3 = _l1.m_data.length * _l1.m_rowHeight + _l1.m_dividers.length * FPUI.DropdownList.DIVIDER_HEIGHT;
        _l1.m_data.push(new FPUI.DropdownListData(displayText, _l3, method));
        _l1.adjustHeight();
        var _l2 = _l1.m_data.length - 1;
        _l1.addLabel(iconName, FPUI.DropdownList.ITEM_LABEL + _l2, _l2);
        _l1.adjustWidth();
        if (_l1.m_data.length > 0 && _l1.m_button)
        {
            _l1.m_button._visible = true;
        } // end if
        return (_l1.m_data.length);
    } // End of the function
    function removeItem()
    {
        var _l1 = this;
        if (_l1.m_data.length > 0)
        {
            _l1.removeLabel(FPUI.DropdownList.ITEM_LABEL + (_l1.m_data.length - 1));
            _l1.m_data.pop();
            _l1.adjustHeight();
            _l1.adjustWidth();
            if (_l1.m_data.length == 0 && _l1.m_button)
            {
                _l1.m_button._visible = false;
            } // end if
        } // end if
    } // End of the function
    function clear()
    {
        var _l1 = this;
        while (_l1.m_data.length > 0)
        {
            _l1.removeItem();
        } // end while
    } // End of the function
    function addDivider()
    {
        var _l1 = this;
        var _l3 = _l1.m_dividers.length;
        var depth = FPUI.DropdownList.FIRST_DIV_DEPTH + _l3;
        var _l2 = "divider" + _l3 + "_mc";
        _l1.m_dividers.push(_l1.attachMovie("ListDivider", _l2, depth));
        _l1[_l2]._x = _l1.list_mc._x;
        _l1[_l2]._y = _l1.m_data.length * _l1.m_rowHeight + _l3 * FPUI.DropdownList.DIVIDER_HEIGHT + 0.500000;
        _l1[_l2]._width = _l1.list_mc._width;
    } // End of the function
    function removeDivider()
    {
        var _l1 = this.m_dividers.pop();
        _l1.removeMovieClip();
    } // End of the function
    function executeSelection()
    {
        var _l1 = this;
        if (_l1.m_selectedItem >= 0 && _l1.m_selectedItem < _l1.m_data.length)
        {
            _l1.m_controller[_l1.m_data[_l1.m_selectedItem].m_method]();
            return (true);
        } // end if
        return (false);
    } // End of the function
    function onMouseDown()
    {
        var _l1 = this;
        _l1.executeSelection();
        if (!_l1.m_button || FlashPaper.Utils.doMouseHitTest(_l1.m_button) == false)
        {
            _l1.setListVisible(false);
        } // end if
    } // End of the function
    function onMouseMove()
    {
        var _l1 = this;
        if (_l1._visible)
        {
            if (FlashPaper.Utils.doMouseHitTest(_l1.list_mc))
            {
                var _l2 = _l1._ymouse;
                if (_l2 < 0)
                {
                    _l2 = 0;
                } // end if
                var _l3 = Math.floor(_l2 / _l1.m_rowHeight);
                _l1.highlightItem(_l3);
            } // end if
        } // end if
    } // End of the function
    function onRollOver()
    {
        var _l1 = this;
        if (_l1._visible)
        {
            _l1.m_cursorManager.setCursorFocus(_l1);
        } // end if
    } // End of the function
    function onRollOut()
    {
        if (this._visible)
        {
            this.highlightItem(-1);
        } // end if
    } // End of the function
    function onReleaseOutside()
    {
        if (this._visible)
        {
            this.highlightItem(-1);
        } // end if
    } // End of the function
    function onKeyDown()
    {
        var _l1 = this;
        var _l2 = Key.getCode();
        switch (_l2)
        {
            case 38:
            {
                _l1.moveSelection(-1);
                if (_l1.m_button)
                {
                    _l1.m_button.pressFocus();
                } // end if
                break;
            } 
            case 40:
            {
                _l1.moveSelection(1);
                if (_l1.m_button)
                {
                    _l1.m_button.pressFocus();
                } // end if
                break;
            } 
            case 9:
            {
                _l1.setListVisible(false);
                break;
            } 
            case 13:
            {
                if (_l1.executeSelection())
                {
                    _l1.setListVisible(false);
                }
                else
                {
                    _l1.onButtonRelease();
                } // end if
                break;
            } 
        } // End of switch
    } // End of the function
    function addLabel(iconName, instanceName, idx)
    {
        var _l1 = this;
        _l1.createEmptyMovieClip(instanceName, FPUI.DropdownList.FIRST_ITEM_DEPTH + idx);
        var _l2 = _l1[instanceName];
        var y = idx * _l1.m_rowHeight + _l1.m_dividers.length * FPUI.DropdownList.DIVIDER_HEIGHT;
        var textFieldXpos = 0;
        if (iconName.length != 0)
        {
            var _l3 = _l2.attachMovie(iconName, "icon", 1);
            var w = Math.min(_l3._width, FPUI.DropdownList.ICON_SIZE);
            var h = Math.min(_l3._height, _l1.m_rowHeight);
            _l3._x = Math.round(FPUI.DropdownList.ICON_X_PAD + (FPUI.DropdownList.ICON_SIZE - w) / 2);
            _l3._y = Math.round(y + (_l1.m_rowHeight - h) / 2);
            _l3._accProps = {silent: true};
            textFieldXpos = FPUI.DropdownList.ICON_X_PAD * 2 + FPUI.DropdownList.ICON_SIZE;
        }
        else
        {
            textFieldXpos = FPUI.DropdownList.TEXT_LABEL_PADDING;
        } // end if
        if (_l1.m_data[idx].m_text.length != 0)
        {
            var textFormat = new TextFormat(FlashPaper.Utils.UIFONT, FlashPaper.Utils.UISMALLFONTSIZE, 0, true);
            _l2.createTextField("textLabel", 2, textFieldXpos, Math.round(y + (_l1.m_rowHeight - FlashPaper.Utils.UISMALLFONTSIZE) / 2 - FPUI.DropdownList.TEXT_FIELD_SLOP), _l1.list_mc._width - textFieldXpos, _l1.m_rowHeight);
            _l2.textLabel.embedFonts = false;
            _l2.textLabel.text = _l1.m_data[idx].m_text;
            _l2.textLabel.setTextFormat(textFormat);
            _l2.textLabel.selectable = false;
            _l2.textLabel._accProps = {silent: true};
        } // end if
        Accessibility.updateProperties();
    } // End of the function
    function removeLabel(instanceName)
    {
        this[instanceName].removeMovieClip();
    } // End of the function
    function adjustHeight()
    {
        var _l1 = this;
        var _l2 = _l1.m_data.length * _l1.m_rowHeight + _l1.m_dividers.length * FPUI.DropdownList.DIVIDER_HEIGHT;
        _l1.list_mc._height = _l2;
    } // End of the function
    function adjustWidth()
    {
        var _l1 = this;
        var _l3 = 0;
        var currTextWidth = 0;
        var icons = false;
        var _l2 = 0;
        while (_l2 < _l1.m_data.length)
        {
            currTextWidth = _l1[FPUI.DropdownList.ITEM_LABEL + _l2].textLabel.textWidth + FPUI.DropdownList.TEXT_FIELD_SLOP * 2;
            if (_l3 < currTextWidth)
            {
                _l3 = currTextWidth;
            } // end if
            if (_l1[FPUI.DropdownList.ITEM_LABEL + _l2].icon)
            {
                icons = true;
            } // end if
            ++_l2;
        } // end while
        _l2 = 0;
        while (_l2 < _l1.m_data.length)
        {
            _l1[FPUI.DropdownList.ITEM_LABEL + _l2].textLabel._width = _l3;
            ++_l2;
        } // end while
        if (icons)
        {
            _l3 = _l3 + (FPUI.DropdownList.ICON_X_PAD * 2 + FPUI.DropdownList.ICON_SIZE + FPUI.DropdownList.TEXT_LABEL_PADDING);
        }
        else
        {
            _l3 = _l3 + FPUI.DropdownList.TEXT_LABEL_PADDING * 2;
        } // end if
        _l1.list_mc._width = _l3;
    } // End of the function
    function highlightItem(index)
    {
        var _l1 = this;
        var _l2 = index;
        _l1.m_highlightMC.clear();
        if (_l2 >= 0 && _l2 < _l1.m_data.length && _l1.m_data[_l2].m_method != "")
        {
            _l1.m_highlightMC._visible = true;
            FPUI.Component.fillRect(_l1.m_highlightMC, 0, _l1.m_data[_l2].m_yOffset, _l1.list_mc._width, _l1.m_rowHeight, FPUI.Component.kRolloverColor);
            _l1.m_selectedItem = _l2;
        }
        else
        {
            _l1.m_highlightMC._visible = false;
            _l1.m_selectedItem = -1;
        } // end if
    } // End of the function
    var m_button = null;
    var m_controller = null;
    var m_cursorManager = null;
    var m_selectedItem = -1;
    var m_data = null;
    var m_rowHeight = 0;
    var m_dividers = null;
    var m_nextLabelYPos = 0;
    var m_numDividers = 0;
    static var ICON_X_PAD = 4;
    static var ICON_SIZE = 16;
    static var TEXT_LABEL_PADDING = 4;
    static var ITEM_LABEL = "listItem_mc";
    static var DIVIDER_HEIGHT = 3;
    static var TEXT_FIELD_SLOP = 2;
    static var FIRST_ITEM_DEPTH = 100;
    static var FIRST_DIV_DEPTH = 200;
} // End of Class
