class FPUI.Scrollbar extends FPUI.Component
{
    var controller;
    function Scrollbar()
    {
        var _l1 = this;
        super();
        _l1.tabEnabled = false;
        _l1.tabChildren = false;
        _l1.m_horizontal = _l1._width > _l1._height;
        _l1.m_width = _l1.m_horizontal ? (_l1._width) : (_l1._height);
        _l1._xscale = 100;
        _l1._yscale = 100;
        _l1.setScrollPosition(0);
        _l1.setSize(_l1.m_width);
    } // End of the function
    function setHorizontal(flag)
    {
        var _l1 = this;
        var _l2 = flag;
        if (_l1.m_horizontal && !_l2)
        {
            _l1._xscale = 100;
            _l1._rotation = 0;
        }
        else if (_l2 && !_l1.m_horizontal)
        {
            _l1._xscale = -100;
            _l1._rotation = -90;
        } // end if
        _l1.m_horizontal = _l2;
    } // End of the function
    static function clearUIFuncs(mc)
    {
        var _l1 = mc;
        _l1.gotoAndStop("disabled");
        _l1.onPress = null;
        _l1.onRelease = null;
        _l1.onDragOver = null;
        _l1.onDragOut = null;
        _l1.onRollOver = null;
        _l1.onRollOut = null;
        _l1.onReleaseOutside = null;
        _l1.useHandCursor = false;
    } // End of the function
    function setScrollProperties(pSize, mxPos)
    {
        var _l1 = this;
        _l1.m_pageSize = pSize;
        _l1.m_maxPos = Math.max(mxPos, 0);
        _l1.m_scrollPosition = Math.max(0, _l1.m_scrollPosition);
        _l1.m_scrollPosition = Math.min(_l1.m_maxPos, _l1.m_scrollPosition);
        FPUI.Scrollbar.clearUIFuncs(_l1.m_upArrowMC);
        FPUI.Scrollbar.clearUIFuncs(_l1.m_downArrowMC);
        FPUI.Scrollbar.clearUIFuncs(_l1.scrollTrack_mc);
        _l1.m_scrollThumbMC.removeMovieClip();
        if (_l1.m_maxPos > 0)
        {
            var _l2;
            _l2 = _l1.m_upArrowMC;
            _l2.gotoAndStop("up");
            if (_l1.m_enable)
            {
                _l2.onPress = _l2.onDragOver = function ()
                {
                    this.controller.startUpDownScroller(this, -1);
                };
                _l2.onRelease = _l2.onDragOut = function ()
                {
                    this.controller.stopScrolling();
                };
                _l2.onRollOver = function ()
                {
                    this.controller.rolloverPart(this);
                };
                _l2.onRollOut = _l2.onReleaseOutside = function ()
                {
                    this.controller.rolloutPart(this);
                };
            } // end if
            _l2._alpha = _l1.m_enable ? (100) : (50);
            _l2 = _l1.m_downArrowMC;
            _l2.gotoAndStop("up");
            if (_l1.m_enable)
            {
                _l2.onPress = _l2.onDragOver = function ()
                {
                    this.controller.startUpDownScroller(this, 1);
                };
                _l2.onRelease = _l2.onDragOut = function ()
                {
                    this.controller.stopScrolling();
                };
                _l2.onRollOver = function ()
                {
                    this.controller.rolloverPart(this);
                };
                _l2.onRollOut = _l2.onReleaseOutside = function ()
                {
                    this.controller.rolloutPart(this);
                };
            } // end if
            _l2._alpha = _l1.m_enable ? (100) : (50);
            _l2 = _l1.scrollTrack_mc;
            _l2.gotoAndStop("enabled");
            if (_l1.m_enable)
            {
                _l2.onPress = _l2.onDragOver = function ()
                {
                    this.controller.startTrackScroller();
                };
                _l2.onRelease = _l2.onDragOut = _l2.onRollOut = function ()
                {
                    this.controller.stopScrolling();
                };
            } // end if
            var tmp = _l1.getScrollPosition();
            _l2 = _l1.attachMovie("mScrollThumb", "m_scrollThumbMC", 3);
            _l2._x = 1;
            _l2._y = 13;
            if (_l1.m_enable)
            {
                _l2.useHandCursor = false;
                _l2.controller = _l1;
                _l2.onPress = function ()
                {
                    this.controller.startDragThumb();
                };
                _l2.onRelease = _l2.onReleaseOutside = function ()
                {
                    this.controller.stopDragThumb();
                };
                _l2.onRollOver = function ()
                {
                    this.controller.rollOverOrOutOfThumb(true);
                };
                _l2.onRollOut = function ()
                {
                    this.controller.rollOverOrOutOfThumb(false);
                };
                _l2.onDragOut = function ()
                {
                    this.controller.dragoutThumb();
                };
            }
            else
            {
                FPUI.Scrollbar.clearUIFuncs(_l2);
            } // end if
            _l2._alpha = _l1.m_enable ? (100) : (50);
            var _l3 = _l1.m_width - 32;
            _l1.m_thumbHeight = Math.max(_l1.m_pageSize / (_l1.m_maxPos + _l1.m_pageSize) * _l3, 26);
            var midHeight = _l1.m_thumbHeight - 10;
            _l2.mc_sliderMid._yScale = midHeight * 100 / _l2.mc_sliderMid._height;
            _l2.mc_sliderMid._y = 2;
            _l2.grips._y = Math.floor(_l1.m_thumbHeight / 2 - _l2.grips._height / 2 - 1.500000);
            _l2.mc_sliderBot._y = 5 + midHeight - 3;
            _l1.m_scrollTop = _l2._y + 3;
            _l1.m_trackHeight = _l3 - _l1.m_thumbHeight + 3;
            _l1.m_scrollBot = _l1.m_scrollTop + _l1.m_trackHeight;
            _l1.m_scrollPosition = Infinity;
            _l1.setScrollPosition(tmp);
        } // end if
    } // End of the function
    function getScrollPosition()
    {
        return (this.m_scrollPosition);
    } // End of the function
    function setScrollPosition(pos)
    {
        var _l1 = this;
        var _l2 = pos;
        if (_l1.m_scrollPosition != _l2)
        {
            _l2 = Math.max(Math.min(_l2, _l1.m_maxPos), 0);
            if (_l1.m_scrollPosition != _l2)
            {
                _l1.m_scrollPosition = _l2;
                _l1.m_scrollThumbMC._y = Math.round(_l1.m_scrollPosition * _l1.m_trackHeight / _l1.m_maxPos) + _l1.m_scrollTop;
                _l1.executeCallBack();
                return (true);
            } // end if
        } // end if
        return (false);
    } // End of the function
    function setLargeScroll(lScroll)
    {
        this.m_largeScroll = lScroll;
    } // End of the function
    function setSmallScroll(sScroll)
    {
        this.m_smallScroll = sScroll;
    } // End of the function
    function setEnabled(enabledFlag)
    {
        var _l1 = this;
        _l1.m_enable = enabledFlag;
        _l1.setScrollProperties(_l1.m_pageSize, _l1.m_maxPos);
    } // End of the function
    function getSize()
    {
        var _l1 = this;
        return (_l1.m_horizontal ? (_l1._width) : (_l1._height));
    } // End of the function
    function getMaxPos()
    {
        return (this.m_maxPos);
    } // End of the function
    function setSize(hgt)
    {
        var _l1 = this;
        if (_l1._height == 1)
        {
        }
        else
        {
            _l1.m_width = hgt + 1;
            var _l2 = _l1.scrollTrack_mc;
            _l2._yscale = 100;
            _l2._yscale = 100 * _l1.m_width / _l2._height;
            if (_l1.m_upArrowMC == undefined)
            {
                _l1.attachMovie("mUpArrow", "m_upArrowMC", 1);
                _l1.attachMovie("mDownArrow", "m_downArrowMC", 2);
                _l1.m_downArrowMC.controller = _l1.m_upArrowMC.controller = _l1;
                _l1.m_upArrowMC.useHandCursor = _l1.m_downArrowMC.useHandCursor = false;
                _l1.m_upArrowMC._x = _l1.m_upArrowMC._y = 0;
                _l1.m_downArrowMC._x = 0;
            } // end if
            _l2.controller = _l1;
            _l1.m_downArrowMC._y = _l1.m_width - 16;
            _l1.setScrollProperties(_l1.m_pageSize, _l1.m_maxPos);
            _l2.topShad._yscale = 100;
            _l2.topShad._xscale = 100;
            _l2.topShad._y = _l2._y + 8;
            _l2.botShad._yscale = 100;
            _l2.botShad._xscale = 100;
            _l2.botShad._y = _l1.m_downArrowMC._y - 8;
        } // end if
    } // End of the function
    function scrollIt(inc, mode)
    {
        var _l1 = this;
        var _l2 = _l1.m_smallScroll;
        if (inc != "one")
        {
            _l2 = _l1.m_largeScroll == 0 ? (_l1.m_pageSize) : (_l1.m_largeScroll);
        } // end if
        _l1.setScrollPosition(_l1.getScrollPosition() + mode * _l2);
    } // End of the function
    function sliderGoTo(state)
    {
        var _l2 = state;
        var _l1 = this.m_scrollThumbMC;
        _l1.mc_sliderTop.gotoAndStop(_l2);
        _l1.mc_sliderBot.gotoAndStop(_l2);
        _l1.mc_sliderMid.gotoAndStop(_l2);
        _l1.grips.gotoAndStop(_l2);
    } // End of the function
    function startDragThumb()
    {
        var _l1 = this;
        _l1.sliderGoTo("down");
        _l1.m_scrollThumbMC.lastY = _l1.m_scrollThumbMC._ymouse;
        _l1.m_scrollThumbMC.onMouseMove = function ()
        {
            this.controller.dragThumb();
        };
    } // End of the function
    function dragThumb()
    {
        var _l1 = this;
        _l1.m_scrollThumbMC.scrollMove = _l1.m_scrollThumbMC._ymouse - _l1.m_scrollThumbMC.lastY + _l1.m_scrollThumbMC._y;
        if (_l1.m_scrollThumbMC.scrollMove < _l1.m_scrollTop)
        {
            _l1.m_scrollThumbMC.scrollMove = _l1.m_scrollTop;
        }
        else if (_l1.m_scrollThumbMC.scrollMove > _l1.m_scrollBot)
        {
            _l1.m_scrollThumbMC.scrollMove = _l1.m_scrollBot;
        } // end if
        _l1.m_scrollThumbMC._y = _l1.m_scrollThumbMC.scrollMove;
        _l1.m_scrollPosition = Math.round(_l1.m_maxPos * (_l1.m_scrollThumbMC._y - _l1.m_scrollTop) / _l1.m_trackHeight);
        _l1.m_isScrolling = true;
        updateAfterEvent();
        _l1.executeCallBack();
    } // End of the function
    function stopDragThumb()
    {
        var _l1 = this;
        _l1.sliderGoTo(_l1.m_mouseOverMC == _l1.m_scrollThumbMC ? ("over") : ("up"));
        _l1.m_isScrolling = false;
        _l1.m_scrollThumbMC.onMouseMove = null;
    } // End of the function
    function rollOverOrOutOfThumb(over)
    {
        var _l1 = this;
        if (over)
        {
            _l1.m_mouseOverMC = _l1.m_scrollThumbMC;
        }
        else if (_l1.m_mouseOverMC == _l1.m_scrollThumbMC)
        {
            _l1.m_mouseOverMC = null;
        } // end if
        _l1.sliderGoTo(over ? ("over") : ("up"));
    } // End of the function
    function dragoutThumb()
    {
        var _l1 = this;
        if (_l1.m_mouseOverMC == _l1.m_scrollThumbMC)
        {
            _l1.m_mouseOverMC = null;
        } // end if
    } // End of the function
    function stopScrolling()
    {
        var _l1 = this;
        _l1.m_downArrowMC.gotoAndStop(_l1.m_mouseOverMC == _l1.m_downArrowMC ? ("over") : ("up"));
        _l1.m_upArrowMC.gotoAndStop(_l1.m_mouseOverMC == _l1.m_upArrowMC ? ("over") : ("up"));
        clearInterval(_l1.m_scrollingIntervalID);
    } // End of the function
    function rolloverPart(part)
    {
        this.m_mouseOverMC = part;
        part.gotoAndStop("over");
    } // End of the function
    function rolloutPart(part)
    {
        if (this.m_mouseOverMC == part)
        {
            this.m_mouseOverMC = null;
        } // end if
        part.gotoAndStop("up");
    } // End of the function
    function startTrackScroller()
    {
        var _l1 = this;
        _l1.trackScroller();
        _l1.m_scrollingIntervalID = setInterval(_l1, "scrollInterval", 500, "page", -1);
    } // End of the function
    function startUpDownScroller(part, dir)
    {
        var _l1 = this;
        part.gotoAndStop("down");
        _l1.scrollIt("one", dir);
        _l1.m_scrollingIntervalID = setInterval(_l1, "scrollInterval", 500, "one", dir);
    } // End of the function
    function scrollInterval(inc, dir)
    {
        var _l1 = this;
        var _l2 = inc;
        clearInterval(_l1.m_scrollingIntervalID);
        if (_l2 == "page")
        {
            _l1.trackScroller();
        }
        else
        {
            _l1.scrollIt(_l2, dir);
        } // end if
        _l1.m_scrollingIntervalID = setInterval(_l1, "scrollInterval", 35, _l2, dir);
    } // End of the function
    function trackScroller()
    {
        var _l1 = this;
        if (_l1.m_scrollThumbMC._y + _l1.m_thumbHeight < _l1._ymouse)
        {
            _l1.scrollIt("page", 1);
        }
        else if (_l1.m_scrollThumbMC._y > _l1._ymouse)
        {
            _l1.scrollIt("page", -1);
        } // end if
    } // End of the function
    var m_scrollPosition = 0;
    var m_maxPos = 0;
    var m_pageSize = 0;
    var m_scrollTop = 0;
    var m_scrollBot = 0;
    var m_trackHeight = 0;
    var m_largeScroll = 0;
    var m_smallScroll = 1;
    var m_thumbHeight = 0;
    var m_horizontal = false;
    var m_isScrolling = false;
    var m_scrollingIntervalID = 0;
    var m_scrollThumbMC = null;
    var m_upArrowMC = null;
    var m_downArrowMC = null;
    var m_mouseOverMC = null;
} // End of Class
