class FPUI.SelectableItem extends FPUI.Component
{
    var m_labelFieldMC, m_itemNum, m_controller, controller, m_width;
    function SelectableItem()
    {
        var _l1 = this;
        super();
        _l1.createTextField("m_labelFieldMC", 1, 0, 0, 1, 1);
        _l1.m_labelFieldMC.embedFonts = false;
        _l1.m_labelFieldMC.selectable = false;
        _l1.m_labelFieldMC.autosize = true;
    } // End of the function
    function calcLabelHeight(s)
    {
        this.setLabel(s);
        return (this.m_labelFieldMC._height);
    } // End of the function
    function setLabel(label)
    {
        var _l1 = this;
        if (_l1.m_labelFieldMC.text != label)
        {
            _l1.m_labelFieldMC.text = label;
            _l1.updateLabelStyle();
        } // end if
    } // End of the function
    function drawItem(itmObj, selected, index)
    {
        this.displayContent(itmObj, selected, index);
    } // End of the function
    function getHighlightHeight()
    {
        return (this.m_highlightMC._height);
    } // End of the function
    function doClickHandler()
    {
        this.m_controller.clickHandler(this.m_itemNum);
    } // End of the function
    function fillHighlight(ca)
    {
        var _l1 = this;
        _l1.m_highlightMC.clear();
        FPUI.Component.fillRect(_l1.m_highlightMC, 0, 0, _l1.m_width, _l1.m_height, ca);
    } // End of the function
    function assignHighlightFunctions(b)
    {
        var _l2 = this;
        var _l1 = _l2.m_highlightMC;
        if (b)
        {
            _l1.onPress = function ()
            {
                var _l1 = this.controller;
                if (_l1.getEnabled())
                {
                    _l1.doClickHandler();
                } // end if
            };
            _l1.onDragOver = function ()
            {
                var _l1 = this.controller;
                if (_l1.m_controller.getFocused())
                {
                    this.onPress();
                } // end if
            };
            _l1.onRollOver = function ()
            {
                var _l1 = this.controller;
                if (_l1.m_controller.hasCursorFocus())
                {
                    _l1.fillHighlight(FPUI.Component.kRolloverColor);
                } // end if
            };
            _l1.onRollOut = function ()
            {
                var _l1 = this.controller;
                _l1.fillHighlight(_l1.m_lastDrawnColor);
            };
        }
        else
        {
            _l1.onPress = _l1.onDragOver = _l1.onRollOver = _l1.onRollOut = null;
        } // end if
    } // End of the function
    function setSize(width, height)
    {
        var _l1 = this;
        var _l3 = width;
        var _l2 = -16384;
        _l1.m_width = _l3;
        _l1.m_height = height;
        _l1.m_labelFieldMC._x = 2;
        _l1.m_labelFieldMC._y = 0;
        _l1.m_labelFieldMC._width = _l3 - 2;
        if (_l1.m_highlightMC == undefined)
        {
            _l1.createEmptyMovieClip("m_highlightMC", _l2);
            _l1.fillHighlight(FPUI.Component.kWhiteBgColor);
            _l1.m_highlightMC._x = _l1.m_highlightMC._y = 0;
            _l1.m_highlightMC.controller = _l1;
            _l1.m_highlightMC.trackAsMenu = true;
            _l1.m_highlightMC.useHandCursor = false;
        } // end if
        _l1.m_highlightMC._width = _l3;
        _l1.m_highlightMC._height = height;
    } // End of the function
    function setEnabled(enabledFlag)
    {
        var _l1 = this;
        if (_l1.m_enable != enabledFlag)
        {
            _l1.m_enable = enabledFlag;
            _l1.updateLabelStyle();
        } // end if
    } // End of the function
    function setMinHighlightWidth(width)
    {
        this.m_highlightMC._width = Math.max(this.m_width, width);
    } // End of the function
    function updateLabelStyle()
    {
        var _l1 = this;
        if (_l1.m_labelFieldMC)
        {
            _l1.m_labelFieldMC.setTextFormat(new TextFormat(FlashPaper.Utils.UIFONT, FlashPaper.Utils.UIFONTSIZE, _l1.m_enable ? (0) : (8947848), _l1.m_boldLF));
            _l1.m_labelFieldMC._height = _l1.m_labelFieldMC.textHeight + 2;
        } // end if
    } // End of the function
    function setLabelBold(bold)
    {
        var _l1 = this;
        if (_l1.m_boldLF != bold)
        {
            _l1.m_boldLF = bold;
            _l1.updateLabelStyle();
        } // end if
    } // End of the function
    function displayContent(itmObj, selected, index)
    {
        var _l1 = this;
        var _l2 = _l1.m_lastDrawnColor;
        if (itmObj)
        {
            _l1.setLabel(itmObj.getDataItemLabel() + " ");
            if (selected && _l1.m_controller.getFocused())
            {
                _l2 = FPUI.Component.kHiliteColor;
            }
            else
            {
                _l2 = FPUI.Component.kWhiteBgColor;
            } // end if
            _l1.assignHighlightFunctions(true);
        }
        else
        {
            _l1.setLabel("");
            _l2 = FPUI.Component.kWhiteBgColor;
            _l1.assignHighlightFunctions(false);
        } // end if
        if (_l1.m_lastDrawnColor != _l2)
        {
            _l1.m_lastDrawnColor = _l2;
            _l1.fillHighlight(_l1.m_lastDrawnColor);
        } // end if
    } // End of the function
    var m_boldLF = false;
    var m_highlightMC = null;
    var m_lastDrawnColor = FPUI.Component.kWhiteBgColor;
} // End of Class
