class FPUI.SelectableList extends FPUI.Component
{
    var m_eatsNavKeysWhenFocused, m_dataProvider, m_enable, m_scrollbar, m_containerMC;
    function SelectableList()
    {
        super();
        this.m_eatsNavKeysWhenFocused = true;
        this.m_selectedItems = new Array();
    } // End of the function
    function setCursorManager(m)
    {
        this.m_cursorManager = m;
    } // End of the function
    function hasCursorFocus()
    {
        var _l1 = this;
        _l1.m_cursorManager.setCursorFocus(_l1);
        return (_l1.m_cursorManager.getCursorFocus() == _l1);
    } // End of the function
    function getLength()
    {
        return (this.m_dataProvider.getLength());
    } // End of the function
    function getSelectedIndex()
    {
        var _l2 = this;
        for (var _l3 in _l2.m_selectedItems)
        {
            var _l1 = _l2.m_selectedItems[_l3];
            return (_l1);
            
        } // end of for...in
        return (undefined);
    } // End of the function
    function getSelectedItem()
    {
        return (this.getItemAt(this.getSelectedIndex()));
    } // End of the function
    function getItemAt(index)
    {
        return (this.m_dataProvider.getItemAt(index));
    } // End of the function
    function setSelectedIndex(index, flag)
    {
        var _l1 = this;
        var _l2 = index;
        if (_l2 >= 0 && _l2 < _l1.getLength() && _l1.m_enable)
        {
            _l1.clearSelected();
            _l1.selectItem(_l2, true);
            _l1.m_lastSelected = _l2;
            _l1.invalidate("updateControl");
            if (flag)
            {
                _l1.executeCallBack();
            } // end if
        } // end if
    } // End of the function
    function setDataProvider(d)
    {
        var _l1 = this;
        _l1.setScrollPosition(0);
        _l1.clearSelected();
        if (_l1.m_dataProvider != null)
        {
            _l1.m_dataProvider.removeView(_l1);
        } // end if
        _l1.m_dataProvider = d;
        if (_l1.m_dataProvider != null)
        {
            _l1.m_dataProvider.addView(_l1);
        } // end if
    } // End of the function
    function setEnabled(enabledFlag)
    {
        var _l2 = this;
        super.setEnabled(enabledFlag);
        _l2.m_enable = enabledFlag;
        var limit = Math.min(_l2.m_numDisplayed, _l2.getLength());
        var _l1 = 0;
        while (_l1 < limit)
        {
            var _l3 = _l2.getNthSelectableItem(_l1);
            _l3.setEnabled(_l2.m_enable);
            ++_l1;
        } // end while
        _l2.m_scrollbar.setEnabled(_l2.m_enable);
        _l2.m_horizScrollbar.setEnabled(_l2.m_enable);
        if (_l2.m_enable)
        {
            _l2.invalidate("updateControl");
        } // end if
    } // End of the function
    function updateControl()
    {
        var _l2 = this;
        if (!_l2.needVS())
        {
            _l2.m_topDisplayed = 0;
        } // end if
        var _l1 = 0;
        while (_l1 < _l2.m_numDisplayed)
        {
            var ci = _l2.getNthSelectableItem(_l1);
            var _l3 = _l2.m_topDisplayed + _l1;
            ci.drawItem(_l2.getItemAt(_l3), _l2.isSelected(_l3), _l3);
            ++_l1;
        } // end while
    } // End of the function
    function setSize(w, h)
    {
        var _l1 = this;
        var pos = _l1.m_topDisplayed;
        _l1.calcNumDisplayed();
        super.setSize(w, h);
        if (_l1.m_containerMC == undefined)
        {
            _l1.createEmptyMovieClip("m_containerMC" + _l1.m_mcCount, _l1.m_mcCount - 2);
            _l1.m_containerMC = _l1["m_containerMC" + _l1.m_mcCount];
        } // end if
        var _l2 = 0;
        while (_l2 < _l1.m_numDisplayed)
        {
            var _l3 = _l1.getNthSelectableItem(_l2);
            if (_l3 == undefined)
            {
                _l3 = _l1.createNthSelectableItem(_l2);
            } // end if
            _l3.setSize(_l1.m_width - _l1.m_scrollOffset, _l1.m_itemHeight);
            _l3._y = _l1.m_itemHeight * _l2;
            ++_l2;
        } // end while
        _l2 = _l1.m_numDisplayed;
        _l3 = _l1.getNthSelectableItem(_l2);
        if (_l3 == undefined)
        {
        }
        else
        {
            _l1.deleteNthSelectableItem(_l2);
            ++_l2;
            
        } // end if
        _l1.updateControl();
        if (_l1.m_maskMC == undefined)
        {
            _l1.createEmptyMovieClip("m_maskMC", _l1.m_mcCount - 1);
            FPUI.Component.fillRect(_l1.m_maskMC, 0, 0, 1, 1, 4278190080.000000);
            _l1.setMask(_l1.m_maskMC);
        } // end if
        _l1.m_maskMC._width = w;
        _l1.m_maskMC._height = h;
        _l1.initScrollBar();
        _l1.setScrollPosition(pos);
    } // End of the function
    function dataViewModelChanged()
    {
        this.modelChanged();
    } // End of the function
    function getItemHeight()
    {
        return (this.m_itemHeight);
    } // End of the function
    function modelChanged()
    {
        this.invalidate("updateControl");
        this.invalidate("initScrollBar");
    } // End of the function
    function measureItmHgt()
    {
        var _l1 = this;
        _l1.attachMovie(_l1.getItemSymbolName(), "tmpItem_mc", 0, {m_controller: _l1, m_itemNum: 0});
        _l1.m_itemHeight = _l1.tmpItem_mc.calcLabelHeight("Sizer: PjtTopg");
        _l1.tmpItem_mc.removeMovieClip();
        delete _l1.tmpItem_mc;
    } // End of the function
    function calcNumDisplayed()
    {
        var _l1 = this;
        _l1.measureItmHgt();
        _l1.m_numDisplayed = Math.floor((_l1.m_height - (_l1.m_horizScrollbar ? (_l1.m_horizScrollbar._height) : (0))) / _l1.m_itemHeight);
    } // End of the function
    function selectItem(index, selectedFlag)
    {
        var _l1 = this;
        var _l2 = index;
        if (selectedFlag != _l1.isSelected(_l2))
        {
            var _l3 = _l1.m_dataProvider.getItemAt(_l2).getDataItemUniqueID();
            if (selectedFlag)
            {
                _l1.m_selectedItems[_l3] = _l2;
            }
            else
            {
                delete _l1.m_selectedItems[_l3];
            } // end if
            if (_l1.isVisible(_l2))
            {
                var ci = _l1.getNthSelectableItem(_l2 - _l1.m_topDisplayed);
                ci.drawItem(_l1.getItemAt(_l2), selectedFlag, _l2);
            } // end if
        } // end if
    } // End of the function
    function isSelected(index)
    {
        var _l1 = this.m_dataProvider.getItemAt(index).getDataItemUniqueID();
        return (this.m_selectedItems[_l1] != undefined);
    } // End of the function
    function isVisible(index)
    {
        var _l1 = this;
        return (index >= _l1.m_topDisplayed && index < _l1.m_topDisplayed + _l1.m_numDisplayed);
    } // End of the function
    function clearSelected()
    {
        var _l1 = this;
        for (var uniqueID in _l1.m_selectedItems)
        {
            var _l2 = _l1.m_selectedItems[uniqueID];
            if (_l1.isVisible(_l2))
            {
                var _l3 = _l1.getNthSelectableItem(_l2 - _l1.m_topDisplayed);
                _l3.drawItem(_l1.getItemAt(_l2), false, _l2);
            } // end if
        } // end of for...in
        delete _l1.m_selectedItems;
        _l1.m_selectedItems = new Array();
    } // End of the function
    function selectionHandler(itemNum)
    {
        var _l1 = this;
        var _l3 = _l1.m_topDisplayed + itemNum;
        var ditem = _l1.getItemAt(_l3);
        if (ditem == undefined)
        {
            _l1.m_changeFlag = false;
        }
        else
        {
            _l1.m_changeFlag = true;
            var shift = Key.isDown(16);
            var ctrl = Key.isDown(17);
            if (_l1.m_singleSelect && !ctrl || !shift && !ctrl)
            {
                _l1.clearSelected();
                _l1.selectItem(_l3, true);
                _l1.m_lastSelected = _l3;
            }
            else if (shift && !_l1.m_singleSelect)
            {
                if (_l1.m_lastSelected == -1)
                {
                    _l1.m_lastSelected = _l3;
                } // end if
                var incr = _l1.m_lastSelected < _l3 ? (1) : (-1);
                _l1.clearSelected();
                var _l2 = _l1.m_lastSelected;
                while (_l2 != _l3)
                {
                    _l1.selectItem(_l2, true);
                    _l2 = _l2 + incr;
                } // end while
                _l1.selectItem(_l3, true);
            }
            else if (ctrl)
            {
                var selectedFlag = _l1.isSelected(_l3);
                if (_l1.m_singleSelect)
                {
                    _l1.clearSelected();
                } // end if
                if (!_l1.m_singleSelect || !selectedFlag)
                {
                    _l1.selectItem(_l3, !selectedFlag);
                } // end if
                _l1.m_lastSelected = _l3;
            } // end if
        } // end if
    } // End of the function
    function moveSelBy(incr)
    {
        var _l1 = this;
        var _l3 = _l1.getSelectedIndex();
        var _l2 = _l3 + incr;
        _l2 = Math.max(0, _l2);
        _l2 = Math.min(_l1.getLength() - 1, _l2);
        if (_l2 == _l3)
        {
        }
        else
        {
            if (_l3 < _l1.m_topDisplayed || _l3 >= _l1.m_topDisplayed + _l1.m_numDisplayed)
            {
                _l1.setScrollPosition(_l3);
            } // end if
            if (_l2 >= _l1.m_topDisplayed + _l1.m_numDisplayed || _l2 < _l1.m_topDisplayed)
            {
                _l1.setScrollPosition(_l1.m_topDisplayed + incr);
            } // end if
            _l1.selectionHandler(_l2 - _l1.m_topDisplayed);
        } // end if
    } // End of the function
    function clickHandler(itmNum)
    {
        var _l1 = this;
        if (!_l1.m_focused)
        {
            _l1.pressFocus();
        } // end if
        _l1.selectionHandler(itmNum);
        _l1.onMouseUp = _l1.releaseHandler;
        if (_l1.m_dragScrollingIntervalID == undefined && _l1.m_scrollbar != undefined)
        {
            _l1.m_dragScrollingIntervalID = setInterval(_l1, "dragScroll", 15);
        } // end if
    } // End of the function
    function releaseHandler()
    {
        var _l1 = this;
        clearInterval(_l1.m_dragScrollingIntervalID);
        _l1.m_dragScrollingIntervalID = undefined;
        if (_l1.m_changeFlag)
        {
            _l1.executeCallBack();
        } // end if
        _l1.m_changeFlag = false;
        delete _l1.onMouseUp;
    } // End of the function
    function setScrollPosition(pos)
    {
        if (this.m_enable)
        {
            this.m_scrollbar.setScrollPosition(pos);
        } // end if
    } // End of the function
    function getItemSymbolName()
    {
        return ("FPUI_SelectableItem");
    } // End of the function
    function createNthSelectableItem(i)
    {
        var _l1 = this;
        var _l2 = i;
        _l1.m_containerMC.attachMovie(_l1.getItemSymbolName(), "fListItem" + _l2, 10 + _l2, {m_controller: _l1, m_itemNum: _l2});
        return (_l1.getNthSelectableItem(_l2));
    } // End of the function
    function getNthSelectableItem(i)
    {
        return (this.m_containerMC["fListItem" + i]);
    } // End of the function
    function deleteNthSelectableItem(i)
    {
        this.m_containerMC["fListItem" + i].removeMovieClip();
        delete this.m_containerMC["fListItem" + i];
    } // End of the function
    function rebuildSelectedItems()
    {
        var _l3 = this;
        var _l1 = 0;
        while (_l1 < _l3.m_dataProvider.getLength())
        {
            var _l2 = _l3.m_dataProvider.getItemAt(_l1).getDataItemUniqueID();
            if (_l3.m_selectedItems[_l2] != undefined)
            {
                _l3.m_selectedItems[_l2] = _l1;
            } // end if
            ++_l1;
        } // end while
    } // End of the function
    function needVS()
    {
        var _l1 = this;
        var _l2 = _l1.m_height - _l1.m_horizScrollbar._height;
        return (_l1.getLength() > _l1.m_numDisplayed && _l2 > FPUI.SelectableList.MIN_SBAR_SIZE);
    } // End of the function
    function needHS()
    {
        var _l2 = this;
        var _l1 = _l2.m_width - _l2.m_scrollbar._width;
        return (_l2.m_virtualWidth > _l1 && _l1 > FPUI.SelectableList.MIN_SBAR_SIZE);
    } // End of the function
    function attachVSBar()
    {
        var _l1 = this;
        _l1.m_scrollbarContainer.attachMovie("Scrollbar", "m_scrollbar", 1);
        _l1.m_scrollbar = _l1.m_scrollbarContainer.m_scrollbar;
        _l1.m_scrollbar.setChangeHandler("scrollHandler", _l1);
    } // End of the function
    function attachHSBar()
    {
        var _l1 = this;
        _l1.m_scrollbarContainer.attachMovie("Scrollbar", "m_horizScrollbar", 2);
        _l1.m_horizScrollbar = _l1.m_scrollbarContainer.m_horizScrollbar;
        _l1.m_horizScrollbar.setHorizontal(true);
        _l1.m_horizScrollbar.setChangeHandler("hScrollHandler", _l1);
    } // End of the function
    function initScrollBar()
    {
        var _l1 = this;
        var _l3 = true;
        var bAdjustHS = true;
        if (!_l1.needVS())
        {
            _l3 = false;
            _l1.m_scrollOffset = 0;
            if (_l1.m_scrollbar)
            {
                _l1.m_scrollbar.removeMovieClip();
                delete _l1.m_scrollbar;
                _l1.invalidate("initScrollBar");
            } // end if
        } // end if
        if (!_l1.needHS())
        {
            bAdjustHS = false;
            if (_l1.m_horizScrollbar)
            {
                _l1.m_horizScrollbar.removeMovieClip();
                delete _l1.m_horizScrollbar;
                _l1.invalidate("initScrollBar");
            } // end if
        } // end if
        if (bAdjustHS || _l3)
        {
            if (_l1.m_scrollbarContainer == undefined)
            {
                _l1.m_mcCount = _l1.m_mcCount + 3;
                _l1.createEmptyMovieClip("sbc_mc" + _l1.m_mcCount, _l1.m_mcCount);
                _l1.m_scrollbarContainer = _l1["sbc_mc" + _l1.m_mcCount];
            } // end if
            if (_l3 && _l1.m_scrollbar == undefined)
            {
                _l1.attachVSBar();
                _l1.invalidate("initScrollBar");
            } // end if
            if (bAdjustHS && _l1.m_horizScrollbar == undefined)
            {
                _l1.attachHSBar();
                _l1.calcNumDisplayed();
                if (_l1.m_scrollbar == undefined && _l1.needVS())
                {
                    _l1.attachVSBar();
                    _l3 = true;
                } // end if
                _l1.invalidate("initScrollBar");
            } // end if
            var i;
            var _l2;
            if (_l3)
            {
                i = _l1.m_horizScrollbar != null ? (_l1.m_horizScrollbar._height) : (0);
                _l2 = _l1.m_scrollbar;
                _l2.setSize(_l1.m_height - i);
                _l2._x = _l1.m_width - _l2._width;
                _l2._y = 0;
                _l2.setLargeScroll(_l1.m_numDisplayed - 1);
                _l1.m_scrollOffset = _l2._width;
                _l2.setScrollProperties(_l1.m_numDisplayed, _l1.getLength() - _l1.m_numDisplayed);
            } // end if
            if (bAdjustHS)
            {
                i = _l1.m_scrollbar != undefined ? (_l1.m_scrollbar._width) : (0);
                _l2 = _l1.m_horizScrollbar;
                _l2.setSize(_l1.m_width - i);
                _l2._x = 0;
                _l2._y = _l1.m_height - _l2._height;
                _l2.setLargeScroll(_l1.m_width);
                _l2.setScrollProperties(_l1.m_width, _l1.m_virtualWidth - (_l1.m_width - i));
                _l2.setSmallScroll(5);
            } // end if
        } // end if
        if (_l1.m_scrollbar._visible && _l1.m_horizScrollbar._visible)
        {
            if (_l1.m_corner == undefined)
            {
                _l1.m_corner = _l1.m_scrollbarContainer.createEmptyMovieClip("m_corner", 3);
                FPUI.Component.fillRect(_l1.m_corner, 0, 0, _l1.m_scrollbar._width, _l1.m_horizScrollbar._height, 4294967295.000000);
            } // end if
            _l1.m_corner._visible = true;
            _l1.m_corner._x = _l1.m_horizScrollbar._x + _l1.m_horizScrollbar._width;
            _l1.m_corner._y = _l1.m_scrollbar._y + _l1.m_scrollbar._height;
        }
        else
        {
            _l1.m_corner._visible = false;
        } // end if
    } // End of the function
    function scrollHandler(scrollBar)
    {
        var _l2 = this;
        var _l1 = scrollBar.getScrollPosition();
        _l2.m_topDisplayed = _l1;
        if (_l2.m_lastPosition != _l1)
        {
            _l2.updateControl();
        } // end if
        _l2.m_lastPosition = _l1;
    } // End of the function
    function hScrollHandler(scrollBar)
    {
        var _l2 = this;
        var _l1 = scrollBar.getScrollPosition();
        if (_l2.m_lastHorizPosition != _l1)
        {
            _l2.m_containerMC._x = -_l1;
        } // end if
        _l2.m_lastHorizPosition = _l1;
    } // End of the function
    function dragScroll()
    {
        var _l1 = this;
        clearInterval(_l1.m_dragScrollingIntervalID);
        var _l2 = 15;
        if (_l1.m_containerMC._ymouse < 0)
        {
            _l1.setScrollPosition(_l1.m_topDisplayed - 1);
            _l1.selectionHandler(0);
            _l2 = Math.max(25, -23.800000 * -_l1.m_containerMC._ymouse + 500);
        }
        else if (_l1.m_containerMC._ymouse > _l1.m_itemHeight * _l1.m_numDisplayed)
        {
            _l1.setScrollPosition(_l1.m_topDisplayed + 1);
            _l1.selectionHandler(_l1.m_numDisplayed - 1);
            _l2 = Math.max(25, -23.800000 * Math.abs(_l1.m_containerMC._ymouse - _l1.m_itemHeight * _l1.m_numDisplayed - 2) + 500);
        } // end if
        _l1.m_dragScrollingIntervalID = setInterval(_l1, "dragScroll", 15);
    } // End of the function
    function onComponentKeyDown()
    {
        var _l3 = this;
        if (_l3.m_focused)
        {
            var _l2 = [40, 38, 34, 33, 36, 35];
            var keyIncrs = [1, -1, _l3.m_numDisplayed - 1, -(_l3.m_numDisplayed - 1), -_l3.getLength(), _l3.getLength()];
            var _l1 = 0;
            while (_l1 < _l2.length)
            {
                if (Key.isDown(_l2[_l1]))
                {
                    _l3.moveSelBy(keyIncrs[_l1]);
                    break;
                } // end if
                ++_l1;
            } // end while
        } // end if
    } // End of the function
    var m_selectedItems = null;
    var m_topDisplayed = 0;
    var m_numDisplayed = 0;
    var m_selectHolder = 0;
    var m_scrollOffset = 0;
    var m_itemHeight = 0;
    var m_changeFlag = false;
    var m_singleSelect = true;
    var m_lastSelected = -1;
    var m_mcCount = 4;
    var m_cursorManager = null;
    var m_virtualWidth = 0;
    static var MIN_SBAR_SIZE = 56;
} // End of Class
