class FPUI.Slider extends FPUI.Component
{
    function Slider()
    {
        var _l1 = this;
        super();
        _l1.m_eatsNavKeysWhenFocused = true;
        _l1.m_snapValues = new Array();
        _l1.m_width = _l1.m_horizontal ? (_l1._width) : (_l1._height);
        _l1._xscale = 100;
        _l1._yscale = 100;
        _l1._rotation = 0;
        _l1.attachMovie("fsl_scrollTrack", "m_scrollTrackMC", _l1.m_depth++, {_y: 1});
        _l1.attachMovie("fsl_pointerThumb", "m_thumbMC", _l1.m_depth++);
        _l1.setEnabled(_l1.enabled);
        _l1.setSliderProperties(_l1.m_minValue, _l1.m_maxValue);
        _l1.setSize(_l1.m_width);
        _l1.setHorizontal(_l1.m_horizontal);
    } // End of the function
    function getValue()
    {
        return (this.m_value);
    } // End of the function
    function setZoomKeyController(controller)
    {
        this.m_keyController = controller;
    } // End of the function
    function setSize(pwidth)
    {
        var _l1 = this;
        var _l2 = pwidth;
        if (_l2 < 4)
        {
            _l2 = 4;
        } // end if
        _l1.m_width = _l2;
        _l1.m_scrollableArea = _l1.m_thumbMC ? (_l1.m_width - 2 - _l1.m_thumbMC._width) : (_l1.m_width - 5);
        _l1.m_scrollTrackMC._x = _l1.m_width / 2;
        _l1.setValue(_l1.m_value);
    } // End of the function
    function setSliderProperties(min, max)
    {
        var _l1 = this;
        if (max <= min)
        {
            return (false);
        } // end if
        _l1.m_maxValue = Number(max);
        _l1.m_minValue = Number(min);
        if (isNaN(_l1.m_maxValue) || isNaN(_l1.m_minValue))
        {
            return (false);
        } // end if
        _l1.m_range = _l1.m_maxValue - _l1.m_minValue;
        _l1.setValue(_l1.m_value);
        return (true);
    } // End of the function
    function setSnapValues(a)
    {
        this.m_snapValues = a;
    } // End of the function
    function setSnapThreshold(i)
    {
        this.m_snapThreshold = i;
    } // End of the function
    function setEnabled(penable)
    {
        var _l1 = this;
        var _l2 = penable;
        super.setEnabled(_l2);
        _l1.enabled = _l2;
        if (!_l2)
        {
            _l1.m_scrollTrackMC.gotoAndStop("disabled");
            _l1.m_thumbMC.gotoAndStop("disabled");
            delete _l1.onPress;
            delete _l1.onRelease;
            delete _l1.onReleaseOutside;
            delete _l1.onRollOver;
            delete _l1.onRollOut;
            delete _l1.onMouseMove;
        }
        else
        {
            _l1.m_scrollTrackMC.gotoAndStop(1);
            _l1.m_thumbMC.gotoAndStop(1);
            _l1.onPress = _l1.myOnPress;
            _l1.onRelease = _l1.myOnRelease;
            _l1.onReleaseOutside = _l1.myOnRelease;
            _l1.onRollOver = _l1.myOnRollOver;
            _l1.onRollOut = _l1.myOnRollOut;
        } // end if
        _l1.setSize(_l1.m_width);
    } // End of the function
    function setHorizontal(horizontal)
    {
        var _l1 = this;
        if (horizontal)
        {
            _l1._rotation = 0;
            _l1.m_scrollTrackMC._rotation = 0;
            _l1.m_scrollTrackMC._yscale = 100;
        }
        else
        {
            _l1._rotation = 90;
            _l1.m_scrollTrackMC._rotation = 180;
            _l1.m_scrollTrackMC._yscale = -100;
        } // end if
        _l1.m_horizontal = horizontal;
        _l1.setValue(_l1.getValue());
    } // End of the function
    function setValue(value)
    {
        var _l1 = this;
        var _l3 = value;
        _l3 = Math.min(Math.max(_l3, _l1.m_minValue), _l1.m_maxValue);
        if (_l1.m_snapValues != undefined && _l1.m_snapValues.length > 0)
        {
            var _l2 = 0;
            while (_l2 < _l1.m_snapValues.length)
            {
                if (_l3 >= _l1.m_snapValues[_l2] - _l1.m_snapThreshold && _l3 <= _l1.m_snapValues[_l2] + _l1.m_snapThreshold)
                {
                    _l3 = _l1.m_snapValues[_l2];
                    break;
                } // end if
                ++_l2;
            } // end while
        } // end if
        _l1.m_value = _l3;
        var xPos = _l1.valueToCoord(_l3);
        _l1.m_thumbMC._x = xPos;
        var ltMC = _l1.m_scrollTrackMC.left_mc;
        var midLtMC = _l1.m_scrollTrackMC.middleLeft_mc;
        var midRtMC = _l1.m_scrollTrackMC.middleRight_mc;
        var rtMC = _l1.m_scrollTrackMC.right_mc;
        ltMC._x = -_l1.m_width / 2;
        if (!_l1.m_horizontal)
        {
            xPos = _l1.valueToCoord(_l1.m_range - _l3 + _l1.m_minValue * 2);
        } // end if
        midLtMC._width = xPos + _l1.m_thumbMC._width / 2;
        midLtMC._x = ltMC._x + ltMC._width;
        midRtMC._width = _l1.m_width - xPos - ltMC._width - rtMC._width - (_l1.m_thumbMC._width - 2) / 2;
        midRtMC._x = midLtMC._x + midLtMC._width;
        rtMC._x = midRtMC._x + midRtMC._width;
        _l1.executeCallBack();
    } // End of the function
    function getValueFromThumb()
    {
        var _l1 = this;
        var _l2;
        if (_l1.m_thumbPressed)
        {
            _l2 = _l1._xmouse - _l1.m_distanceFromCenter;
        }
        else
        {
            _l2 = _l1._xmouse - _l1.m_thumbMC._width / 2;
        } // end if
        _l2 = Math.max(1, Math.min(_l2, _l1.m_scrollableArea + 1));
        return (_l1.coordToValue(_l2));
    } // End of the function
    function setValueFromThumb()
    {
        this.setValue(this.getValueFromThumb());
    } // End of the function
    function myOnMouseMove()
    {
        this.setValueFromThumb();
    } // End of the function
    function go(s)
    {
        var _l1 = this;
        if (s == "up")
        {
            if (_l1.getFocused())
            {
                _l1.m_thumbMC.gotoAndStop("focus");
            }
            else
            {
                _l1.m_thumbMC.gotoAndStop(1);
            } // end if
        }
        else
        {
            _l1.m_thumbMC.gotoAndStop(s);
        } // end if
    } // End of the function
    function onComponentKillFocus()
    {
        super.onComponentKillFocus();
        this.go("up");
    } // End of the function
    function myOnRelease()
    {
        var _l1 = this;
        _l1.m_focused = false;
        _l1.setValueFromThumb();
        delete _l1.onMouseMove;
        _l1.m_thumbPressed = false;
        _l1.m_distanceFromCenter = 0;
        _l1.go("up");
        Selection.setFocus(null);
    } // End of the function
    function myOnPress()
    {
        var _l1 = this;
        _l1.pressFocus();
        _l1.m_thumbPressed = _l1.m_thumbMC.hitTest(_root._xmouse, _root._ymouse);
        if (_l1.m_thumbPressed)
        {
            _l1.m_distanceFromCenter = _l1._xmouse - _l1.m_thumbMC._x;
        } // end if
        _l1.setValueFromThumb();
        _l1.onMouseMove = _l1.myOnMouseMove;
        _l1.go("pressed");
    } // End of the function
    function myOnRollOver()
    {
        this.go("over");
    } // End of the function
    function myOnRollOut()
    {
        this.go("up");
    } // End of the function
    function coordToValue(coord)
    {
        var _l1 = this;
        if (_l1.m_horizontal)
        {
            return ((coord - 1) / _l1.m_scrollableArea * _l1.m_range + _l1.m_minValue);
            
        }
        else
        {
            return (Math.abs(coord - 1 - _l1.m_scrollableArea) / _l1.m_scrollableArea * _l1.m_range + _l1.m_minValue);
        } // end if
    } // End of the function
    function valueToCoord(value)
    {
        var _l1 = this;
        if (_l1.m_horizontal)
        {
            return ((value - _l1.m_minValue) / _l1.m_range * _l1.m_scrollableArea + 1);
            
        }
        else
        {
            return (Math.abs(value - (_l1.m_range + _l1.m_minValue)) / _l1.m_range * _l1.m_scrollableArea + 1);
        } // end if
    } // End of the function
    function onComponentKeyDown()
    {
        var _l1 = this;
        if (!_l1.m_enable)
        {
        }
        else
        {
            var increase = !_l1.m_horizontal ? (38) : (39);
            var decrease = !_l1.m_horizontal ? (40) : (37);
            var _l2 = Key.getCode();
            var _l3 = Key.isDown(17) ? (_l1.m_lgStepAmount) : (_l1.m_smStepAmount);
            if (_l2 == increase)
            {
                if (_l1.m_keyController != null)
                {
                    _l1.m_keyController.zoomIn();
                }
                else
                {
                    _l1.setValue(_l1.m_value + _l3);
                } // end if
            }
            else if (_l2 == decrease)
            {
                if (_l1.m_keyController != null)
                {
                    _l1.m_keyController.zoomOut();
                }
                else
                {
                    _l1.setValue(_l1.m_value - _l3);
                } // end if
            } // end if
        } // end if
    } // End of the function
    var m_depth = 0;
    var m_minValue = 0;
    var m_maxValue = 100;
    var m_range = 100;
    var m_value = 0;
    var m_smStepAmount = 1;
    var m_lgStepAmount = 5;
    var m_horizontal = true;
    var m_thumbMC = null;
    var m_scrollTrackMC = null;
    var m_snapValues = null;
    var m_snapThreshold = 0;
    var m_thumbPressed = false;
    var m_distanceFromCenter = 0;
    var m_scrollableArea = 0;
    var m_keyController = null;
} // End of Class
