class FPUI.Tree extends FPUI.SelectableList
{
    function Tree()
    {
        var _l1 = this;
        super();
        _l1._x = Math.round(_l1._x);
        _l1._y = Math.round(_l1._y);
        _l1.m_width = _l1._width;
        _l1.m_height = _l1._height;
        _l1._yscale = _l1._xscale = 100;
        _l1.setSize(_l1.m_width, _l1.m_height);
    } // End of the function
    function refresh()
    {
        this.refreshBranch(-1);
    } // End of the function
    function refreshBranch(index)
    {
        var _l1 = this;
        _l1.m_dataProvider.updateBranch(index);
        _l1.rebuildSelectedItems();
        _l1.invalidate("updateControl");
    } // End of the function
    function setDataProvider(dataProvider)
    {
        var _l1 = this;
        _l1.clearSelected();
        super.setDataProvider(dataProvider);
        _l1.resetTreeWidth();
        _l1.refresh();
    } // End of the function
    function setSize(w, h)
    {
        super.setSize(w, h);
        this.setMinHighlightWidth(Stage.width);
    } // End of the function
    function moveSelBy(incr)
    {
        var _l1 = this.getSelectedItem();
        if (_l1 != null && _l1.isOnOpenBranch())
        {
            super.moveSelBy(incr);
        } // end if
        this.executeCallBack();
    } // End of the function
    function resetTreeWidth()
    {
        var _l1 = this;
        _l1.m_virtualWidth = _l1.m_dataProvider.calcWidth();
        _l1.setMinHighlightWidth(Stage.width);
        _l1.invalidate("updateControl");
    } // End of the function
    function setMinTreeWidth(w)
    {
        var _l1 = this;
        if (w > _l1.m_virtualWidth)
        {
            _l1.m_virtualWidth = w;
            _l1.setMinHighlightWidth(_l1.m_virtualWidth);
            _l1.invalidate("initScrollBar");
        } // end if
    } // End of the function
    function setMinHighlightWidth(width)
    {
        var _l2 = this;
        var _l3 = width;
        var _l1 = 0;
        while (_l1 < _l2.m_numDisplayed)
        {
            _l2.getNthSelectableItem(_l1).setMinHighlightWidth(_l3);
            ++_l1;
        } // end while
    } // End of the function
    function onComponentKeyDown()
    {
        var _l2 = this;
        if (_l2.m_focused && _l2.m_enable)
        {
            if (Key.isDown(32))
            {
                var _l1 = _l2.getSelectedItem();
                if (_l1 != null && _l1.isBranch())
                {
                    _l1.setIsOpen(!_l1.isOpen());
                    _l2.refreshBranch(_l2.getSelectedIndex());
                } // end if
            }
            else
            {
                super.onComponentKeyDown();
            } // end if
        } // end if
    } // End of the function
    function getItemSymbolName()
    {
        return ("FPUI_TreeSelectableItem");
    } // End of the function
} // End of Class
