class FPUI.TreeDataProvider extends FPUI.DataProvider
{
    function TreeDataProvider(root)
    {
        super();
        this.setRootNode(root);
    } // End of the function
    function setRootNode(root)
    {
        var _l1 = this;
        _l1.m_root = root;
        _l1.removeAll();
        if (_l1.m_root != null)
        {
            _l1.m_root.setIsOpen(true);
            _l1.addNodeAt(-1, -1, _l1.m_root);
        } // end if
        _l1.updateViews();
    } // End of the function
    function calcWidth()
    {
        return (this.doCalcWidth(this.m_root, 0));
    } // End of the function
    function doCalcWidth(node, w)
    {
        var _l3 = w;
        if (node.getLastDrawnWidth() > _l3)
        {
            _l3 = node.getLastDrawnWidth();
        } // end if
        if (node.isOpen())
        {
            var cn = node.getChildNodes();
            var _l1 = 0;
            while (_l1 < cn.length)
            {
                var _l2 = this.doCalcWidth(cn[_l1], _l3);
                if (_l2 > _l3)
                {
                    _l3 = _l2;
                } // end if
                ++_l1;
            } // end while
        } // end if
        return (_l3);
    } // End of the function
    function addNodeAt(n, level, node)
    {
        var _l2 = n;
        node.setLevel(level);
        if (_l2 >= 0)
        {
            this.addItemAt(_l2, node);
        } // end if
        ++_l2;
        if (node.isBranch() && node.isOpen())
        {
            ++level;
            var _l3 = node.getChildNodes();
            var _l1 = 0;
            while (_l1 < _l3.length)
            {
                _l2 = this.addNodeAt(_l2, level, _l3[_l1]);
                ++_l1;
            } // end while
        } // end if
        return (_l2);
    } // End of the function
    function getNthNode(index)
    {
        return (this.getItemAt(index));
    } // End of the function
    function updateBranch(index)
    {
        var _l2 = this;
        var node = index == -1 ? (_l2.m_root) : (_l2.getNthNode(index));
        if (!node.isBranch())
        {
        }
        else
        {
            var _l3 = index + 1;
            var level = node.getLevel() + 1;
            var _l1 = _l3;
            while (_l1 < _l2.getLength() && _l2.getNthNode(_l1).getLevel() >= level)
            {
                ++_l1;
            } // end while
            _l2.removeItemsAt(_l3, _l1 - _l3);
            if (node.isOpen())
            {
                var kids = node.getChildNodes();
                _l1 = 0;
                while (_l1 < kids.length)
                {
                    _l3 = _l2.addNodeAt(_l3, level, kids[_l1]);
                    ++_l1;
                } // end while
            } // end if
        } // end if
    } // End of the function
    var m_root = null;
} // End of Class
