class FPUI.TreeNode
{
    function TreeNode(s, d)
    {
        var _l1 = this;
        _l1.m_label = s;
        _l1.m_data = d;
        _l1.m_kids = new Array();
        _l1.m_uniqueID = ++FPUI.TreeNode.m_nextID;
    } // End of the function
    function getDataItemLabel()
    {
        return (this.m_label);
    } // End of the function
    function getDataItemData()
    {
        return (this.m_data);
    } // End of the function
    function getDataItemUniqueID()
    {
        return (this.m_uniqueID);
    } // End of the function
    function getLevel()
    {
        return (this.m_level);
    } // End of the function
    function setLevel(lev)
    {
        this.m_level = lev;
    } // End of the function
    function getLastDrawnWidth()
    {
        return (this.m_lastDrawnWidth);
    } // End of the function
    function setLastDrawnWidth(i)
    {
        this.m_lastDrawnWidth = i;
    } // End of the function
    function addNode(kid)
    {
        this.addChildNodeAt(this.m_kids.length, kid);
    } // End of the function
    function addChildNodeAt(i, kid)
    {
        var _l1 = this;
        var _l2 = kid;
        _l1.m_branch = true;
        _l1.m_kids.splice(i, 0, _l2);
        _l2.m_parent = _l1;
        _l2.m_level = _l1.m_level + 1;
    } // End of the function
    function getChildNodes()
    {
        return (this.m_kids);
    } // End of the function
    function getLength()
    {
        return (this.m_kids.length);
    } // End of the function
    function isBranch()
    {
        return (this.m_branch);
    } // End of the function
    function isOpen()
    {
        return (this.m_open);
    } // End of the function
    function setIsOpen(b)
    {
        this.m_open = b;
    } // End of the function
    function isOnOpenBranch()
    {
        var _l2 = true;
        var _l1 = this.m_parent;
        while (_l2 && _l1 != null)
        {
            _l2 = _l2 & _l1.isOpen();
            _l1 = _l1.m_parent;
        } // end while
        return (_l2);
    } // End of the function
    static var m_nextID = 0;
    var m_label = "";
    var m_data = null;
    var m_open = false;
    var m_branch = false;
    var m_level = 0;
    var m_kids = null;
    var m_parent = null;
    var m_lastDrawnWidth = 0;
    var m_uniqueID = 0;
} // End of Class
