class FPUI.TreeSelectableItem extends FPUI.SelectableItem
{
    var tree, node, index;
    function TreeSelectableItem()
    {
        super();
    } // End of the function
    function displayContent(nodeObj, selected, index)
    {
        var _l1 = this;
        var _l2 = nodeObj;
        super.displayContent(_l2, selected, index);
        var treeControl = _l1.m_controller;
        var iconName = _l2 && !_l2.isBranch() ? ("ftree_icon_leaf") : ("");
        if (_l2 == null || _l1.m_iconName != iconName)
        {
            _l1.m_iconName = "";
            if (_l1.m_iconMC)
            {
                _l1.m_iconMC.removeMovieClip();
            } // end if
        } // end if
        _l1.m_connectorMC.ex.clear();
        if (_l2 == null)
        {
        }
        else
        {
            if (_l1.m_connectorMC == undefined)
            {
                _l1.createEmptyMovieClip("m_connectorMC", 3001);
            } // end if
            _l1.m_connectorMC._x = 2;
            var ch = _l1.getHighlightHeight();
            var cw = 17;
            var nodeLevel = _l2.getLevel();
            if (_l2.isBranch())
            {
                _l1.setLabelBold(true);
                var mx = Math.floor(cw / 2) + nodeLevel * cw;
                var my = Math.floor(ch / 2);
                var _l3 = _l1.m_connectorMC.ex;
                if (_l3 == undefined)
                {
                    _l3 = _l1.m_connectorMC.createEmptyMovieClip("ex", 1);
                } // end if
                _l1.drawExpander(_l3, mx, my, _l2.isOpen());
                _l3.node = _l2;
                _l3.index = index;
                _l3.tree = treeControl;
                _l3.useHandCursor = false;
                _l3.trackAsMenu = true;
                _l3.onRelease = function ()
                {
                    var _l1 = this.tree;
                    if (_l1.getEnabled())
                    {
                        var _l2 = this.node;
                        _l2.setIsOpen(!_l2.isOpen());
                        var _l3 = this.index;
                        _l1.refreshBranch(_l3);
                        if (!_l1.getFocused())
                        {
                            _l1.pressFocus();
                        } // end if
                    } // end if
                };
            }
            else
            {
                _l1.setLabelBold(false);
            } // end if
            if (_l1.m_iconMC == undefined)
            {
                _l1.attachMovie(iconName, "m_iconMC", 3000);
                _l1.m_iconName = iconName;
            } // end if
            var offset = _l1.m_connectorMC._x + (nodeLevel + 1) * cw - 1;
            if (_l1.m_iconMC)
            {
                _l1.m_iconMC._x = Math.round(offset);
                _l1.m_iconMC._y = Math.round((ch - _l1.m_iconMC._height) / 2);
                _l1.m_iconMC.useHandCursor = false;
                offset = offset + (_l1.m_iconMC._width + 4);
            } // end if
            _l1.m_labelFieldMC._x = Math.round(offset);
            if (_l1.m_controller.getItemHeight() < ch)
            {
                _l1.m_labelFieldMC._y = Math.round((ch - _l1.m_controller.getItemHeight()) / 2);
            } // end if
            if (_l2 != null)
            {
                _l2.setLastDrawnWidth(offset + _l1.m_labelFieldMC._x + _l1.m_labelFieldMC.textWidth);
                treeControl.setMinTreeWidth(_l2.getLastDrawnWidth());
            } // end if
            _l1._y = Math.round(_l1._y);
        } // end if
    } // End of the function
    function drawExpander(ex, x, y, isOpen)
    {
        var _l2 = ex;
        _l2.clear();
        var _l1 = 6;
        _l2.beginFill(16777215, 0);
        _l2.moveTo(-_l1, -_l1);
        _l2.lineTo(_l1, -_l1);
        _l2.lineTo(_l1, _l1);
        _l2.lineTo(-_l1, _l1);
        _l2.lineTo(-_l1, -_l1);
        _l2.endFill();
        var _l3 = 7697781;
        _l1 = 3;
        _l2.beginFill(_l3);
        _l2.moveTo(-_l1, -_l1);
        _l2.lineTo(_l1, 0);
        _l2.lineTo(-_l1, _l1);
        _l2.lineTo(-_l1, -_l1);
        _l2.endFill();
        _l2._x = Math.floor(x);
        _l2._y = Math.floor(y);
        _l2._rotation = isOpen ? (90) : (0);
    } // End of the function
    var m_iconName = "";
} // End of Class
