class FlashPaper.DividerView extends MovieClip
{
    var useHandCursor, gripper_mc, m_mainView, _height;
    function DividerView()
    {
        super();
        this.useHandCursor = false;
        this.gripper_mc.useHandCursor = false;
    } // End of the function
    function setMainView(p_mainView)
    {
        var _l1 = this;
        _l1.m_mainView = p_mainView;
        _l1.m_mainView.addListener(_l1);
        _l1.onResize();
    } // End of the function
    function handleContractionClick()
    {
        var _l1 = this;
        var _l2 = _l1.m_mainView.getSidebarWidth();
        if (_l2 > 0)
        {
            _l1.m_savedTreeWidth = _l2;
            _l1.m_mainView.setSidebarWidth(0);
        }
        else
        {
            _l1.m_mainView.setSidebarWidth(_l1.m_savedTreeWidth);
        } // end if
    } // End of the function
    function onMouseDown()
    {
        var _l1 = this;
        _l1.m_mouseMovedEnough = false;
        _l1.m_mouseDownInGripper = FlashPaper.Utils.doMouseHitTest(_l1.gripper_mc);
        if (FlashPaper.Utils.doMouseHitTest(_l1))
        {
            _l1.m_mouseDown = true;
            _l1.m_mouseX = _l1.m_mainView.getMouseX();
            _l1.m_mouseTW = _l1.m_mainView.getSidebarWidth();
        } // end if
    } // End of the function
    function onMouseMove()
    {
        var _l1 = this;
        if (_l1.m_mouseDown)
        {
            var _l2 = _l1.m_mainView.getMouseX();
            if (Math.abs(_l2 - _l1.m_mouseX) >= 3)
            {
                _l1.m_mouseMovedEnough = true;
            } // end if
            if (_l1.m_mouseMovedEnough)
            {
                _l1.m_mainView.setSidebarWidth(_l1.m_mouseTW + _l2 - _l1.m_mouseX);
            } // end if
        } // end if
    } // End of the function
    function onMouseUp()
    {
        var _l1 = this;
        _l1.m_mouseDown = false;
        if (!_l1.m_mouseMovedEnough && _l1.m_mouseDownInGripper)
        {
            _l1.handleContractionClick();
        } // end if
    } // End of the function
    function onRollOver()
    {
        var _l1 = this;
        _l1.m_mainView.setCursorFocus(_l1);
        _l1.m_mainView.setCursor(_l1, "divider");
    } // End of the function
    function onRollOut()
    {
        this.m_mainView.setCursor(this, "");
    } // End of the function
    function onReleaseOutside()
    {
        this.m_mainView.setCursor(this, "");
    } // End of the function
    function onResize()
    {
        this._height = this.m_mainView.getDocViewHeight();
    } // End of the function
} // End of Class
