class FlashPaper.MainView
{
    var m_mainMC, m_viewMode, m_isHandheld, m_treeWidth, m_docDpiToScreenDpiFactor, m_mainView, m_toolbarView, m_treeView, m_dividerView, m_documentView, controller, focus_mc;
    function MainView(p_main_mc)
    {
        AsBroadcaster.initialize(this);
        this.m_mainMC = p_main_mc;
        this.m_accSilentList = new Array();
        this.m_viewMode = this.getConfigString("INITIAL_VIEW");
        this.m_currentScale = parseFloat(this.m_viewMode);
        if (!isNaN(this.m_currentScale) && this.m_currentScale >= FlashPaper.MainView.ZOOM_MIN && this.m_currentScale <= FlashPaper.MainView.ZOOM_MAX)
        {
            this.m_viewMode = "zoom";
        }
        else
        {
            this.m_currentScale = 100;
        } // end if
        this.m_isHandheld = this.getConfigString("HANDHELD") == "true";
        this.m_treeWidth = FlashPaper.MainView.TREE_WIDTH;
        this.m_screenDPI = parseFloat(this.getConfigString("SCREEN_DPI"));
        this.m_docDpiToScreenDpiFactor = this.m_screenDPI / this.m_mainMC.dpi;
        this.m_mainMC.m_mainView = this;
        this.m_mainMC.onEnterFrame = function ()
        {
            var _l2 = this;
            var _l1 = _l2.m_mainView;
            _l1.loadPages();
            if (_l2._currentframe == _l2._totalframes)
            {
                _l2.stop();
                delete _l2.onEnterFrame;
                _l1.broadcastMessage("internal_onDocumentLoaded");
                _l1.onResize();
            } // end if
        };
        this.m_mainMC.onMouseDown = function ()
        {
            this.m_mainView.updateCursor();
            if (FPUI.Component.focusedComponent != null && FlashPaper.Utils.doMouseHitTest(FPUI.Component.focusedComponent) == false)
            {
                Selection.setFocus(null);
            } // end if
        };
        this.m_mainMC.onMouseMove = this.m_mainMC.onMouseUp = function ()
        {
            this.m_mainView.updateCursor();
        };
        this.m_mainMC.onUnload = function ()
        {
            this.m_mainView.cleanupCursor();
        };
        for (var i in this.m_mainMC.cursors_mc)
        {
            this.m_mainMC.cursors_mc[i]._visible = false;
        } // end of for...in
        if (this.m_mainMC == _level0)
        {
            Stage.showMenu = false;
            Stage.align = "TL";
            Stage.scaleMode = "noScale";
            this.m_mainMC._xscale = 100;
            this.m_mainMC._yscale = 100;
        }
        else
        {
            this.setForcedWidthAndHeight(550, 400);
        } // end if
        this.m_mainMC.controller = this;
        this.m_mainMC._quality = "BEST";
        this.m_toolbarView = new FlashPaper.ToolbarView(this, this.m_mainMC, this.getConfigString("POPUP_ENABLED") == "true");
        p_main_mc.toolbar_mc._xscale = 100;
        p_main_mc.toolbar_mc._yscale = 100;
        this.m_treeView = new FlashPaper.TreeView(this, this.m_mainMC.tree_mc);
        this.m_mainMC.tree_mc._xscale = 100;
        this.m_mainMC.tree_mc._yscale = 100;
        this.m_dividerView = this.m_mainMC.divider_mc;
        this.m_dividerView._xscale = 100;
        this.m_dividerView._yscale = 100;
        this.m_dividerView.setMainView(this);
        this.m_documentView = this.m_mainMC.document_mc;
        this.m_documentView._xscale = 100;
        this.m_documentView._yscale = 100;
        this.m_documentView.setMainView(this, this.getConfigString("SEARCH_TO_TOP") == "true");
        if (this.m_mainMC.fpBookmarks_array === undefined || this.m_mainMC.fpBookmarks_array.length == 0 || this.getConfigString("HIDE_SIDEBAR") == "true")
        {
            this.m_mainMC.divider_mc._visible = false;
            this.m_mainMC.tree_mc._visible = false;
            this.m_treeWidth = 0;
            delete this.m_mainMC.fpBookmarks_array;
        } // end if
        var messages = this.m_mainMC.message_mc;
        messages.setController(this);
        messages.setCursorManager(this);
        messages.setListVisible(false);
        var i = 1;
        while (i <= this.getNumberOfPages())
        {
            var width_i = eval("pageWidth" + i);
            if (width_i == undefined)
            {
                width_i = this.getDocumentWidth();
            } // end if
            var height_i = eval("pageHeight" + i);
            if (height_i == undefined)
            {
                height_i = this.getDocumentHeight();
            } // end if
            ++this.m_numPages;
            this.broadcastMessage("internal_onAddPage", width_i, height_i);
            ++i;
        } // end while
        Stage.addListener(this);
        Key.addListener(this);
        this.onResize();
        this.setCurrentPage(parseInt(this.getConfigString("INITIAL_PAGE")));
        var b = this.getConfigString("INITIAL_BOOKMARK");
        if (b != "")
        {
            var bm = this.findBookmark(b, this.m_mainMC.fpBookmarks_array);
            if (bm != null)
            {
                this.goToAnchor(this.m_mainMC.fpAnchors_o[bm.anchorName_str]);
            } // end if
        } // end if
        var b = this.getConfigString("INITIAL_ANCHOR");
        if (b != "")
        {
            var anchor = this.m_mainMC.fpAnchors_o[b];
            if (anchor)
            {
                this.goToAnchor(anchor);
            } // end if
        } // end if
        this.onResize2();
        this.initializeTabbing();
        this.initializeAccessibility();
    } // End of the function
    static function disableLMR(mc)
    {
        var _l1 = mc;
        _l1.tabEnabled = false;
        _l1.middle.tabEnabled = false;
        _l1.left.tabEnabled = false;
        _l1.right.tabEnabled = false;
    } // End of the function
    function initializeTabbing()
    {
        var _l2 = this.m_mainMC.toolbar_mc.controls_mc;
        var _l1;
        _l1 = this.m_mainMC;
        _l1.toolbar_mc.tabEnabled = false;
        _l1.cursors_mc.tabEnabled = false;
        _l1.tree_mc.tabEnabled = false;
        _l1.divider_mc.tabEnabled = false;
        _l1.divider_mc.gripper_mc.tabEnabled = false;
        _l1 = this.m_mainMC.document_mc;
        _l1.tabEnabled = true;
        _l1.focusEnabled = true;
        _l1.bg_mc.tabEnabled = false;
        _l1.pages_mc.tabEnabled = false;
        _l1.corner_mc.tabEnabled = false;
        _l1 = this.m_mainMC.toolbar_mc.toolbarBg_mc;
        _l1.tabEnabled = false;
        _l1.middle_mc.tabEnabled = false;
        _l1.middle_mc.fill_mc.tabEnabled = false;
        _l1.middle_mc.dropShadow_mc.tabEnabled = false;
        _l1.right_mc.tabEnabled = false;
        _l1.left_mc.tabEnabled = false;
        _l1 = this.m_mainMC.toolbar_mc.brandClip_mc;
        _l1.tabEnabled = false;
        _l1.gotoLink_btn.tabEnabled = false;
        _l1._icon.tabEnabled = false;
        _l1 = _l2;
        _l1.tabEnabled = false;
        _l1.dividePager_mc.tabEnabled = false;
        _l1.divideZoom_mc.tabEnabled = false;
        _l1.dividePrint_mc.tabEnabled = false;
        _l1.divideTools_mc.tabEnabled = false;
        _l1 = _l2.find_mc;
        _l1.tabEnabled = false;
        FlashPaper.MainView.disableLMR(_l1.findBg_mc);
        _l1 = _l2.currZoom_mc;
        _l1.tabEnabled = false;
        FlashPaper.MainView.disableLMR(_l1.currZoomBg_mc);
        _l1 = _l2.currPg_mc;
        _l1.tabEnabled = false;
        FlashPaper.MainView.disableLMR(_l1.currPgBg_mc);
        _l2.numPgs_txt.tabEnabled = false;
        _l2.prevNext_mc.tabEnabled = false;
        var _l3 = this.m_nextTabIndex;
        this.m_mainMC.toolbar_mc.tabIndex = _l3++;
        _l2.panTool_mc.tabIndex = _l3++;
        _l2.selectTool_mc.tabIndex = _l3++;
        _l2.find_mc.find_txt.tabIndex = _l3++;
        _l2.find_mc.findButton_mc.tabIndex = _l3++;
        _l2.divideZoom_mc.tabIndex = _l3++;
        _l2.zoom_sld.tabIndex = _l3++;
        _l2.currZoom_mc.currZoom_txt.tabIndex = _l3++;
        _l2.fitPage_mc.tabIndex = _l3++;
        _l2.fitWidth_mc.tabIndex = _l3++;
        _l2.currPg_mc.currPg_txt.tabIndex = _l3++;
        _l2.prevNext_mc.prevPg_mc.tabIndex = _l3++;
        _l2.prevNext_mc.nextPg_mc.tabIndex = _l3++;
        _l2.print_mc.tabIndex = _l3++;
        _l2.popup_mc.tabIndex = _l3++;
        _l2.hiddenToolsBtn_mc.tabIndex = _l3++;
        _l1 = this.m_mainMC.toolbar_mc;
        _l1.createEmptyMovieClip("accessible_mc", -16384);
        _l1.accessible_mc.visible = true;
        _l1.accessible_mc.tabIndex = _l3++;
        _l1.accessible_mc.tabEnabled = false;
        _l1.accessible_mc.createEmptyMovieClip("prevPg_mc", 1);
        _l1.accessible_mc.createEmptyMovieClip("nextPg_mc", 2);
        _l1.accessible_mc.prevPg_mc.tabIndex = _l3++;
        _l1.accessible_mc.nextPg_mc.tabIndex = _l3++;
        this.m_mainMC.document_mc.tabIndex = _l3++;
        this.m_nextTabIndex = _l3;
    } // End of the function
    function getLanguageObject()
    {
        var _l1 = this.m_mainMC.fpLocalizations_o[System.capabilities.language];
        if (_l1 == null)
        {
            _l1 = this.m_mainMC.fpLocalizations_o.en;
        } // end if
        return (_l1);
    } // End of the function
    function initializeAccessibility()
    {
        var _l1 = this;
        var _l3 = _l1.getLanguageObject();
        _l1.m_mainMC._accProps = new Object();
        _l1.m_mainMC._accProps.name = _l3.DOCUMENT;
        _l1.makeSilent(_l1.m_mainMC.tree_mc, true);
        _l1.makeSilent(_l1.m_mainMC.divider_mc, true);
        var toolbar_mc = _l1.m_mainMC.toolbar_mc;
        _l1.addAccProp(toolbar_mc, _l3.TOOLBAR, "");
        _l1.makeSilent(toolbar_mc.toolbarBg_mc, true);
        _l1.makeSilent(toolbar_mc.brandClip_mc, true);
        _l1.makeSilent(toolbar_mc.brandClip_mc._icon, true);
        _l1.makeSilent(toolbar_mc.popup_mc, true);
        var _l2 = toolbar_mc.controls_mc;
        _l1.makeSilent(_l2.panTool_mc, true);
        _l1.makeSilent(_l2.selectTool_mc, true);
        _l1.makeSilent(_l2.divideTools_mc, true);
        _l1.makeSilent(_l2.find_mc.findBg_mc, true);
        _l1.addAccProp(_l2.find_mc.find_txt, _l3.FIND, "Search for text by typing in search keywords and hitting the enter key.");
        _l1.addAccProp(_l2.find_mc.findButton_mc, _l3.FIND, "");
        _l1.makeSilent(_l2.divideZoom_mc, true);
        _l1.makeSilent(_l2.zoom_sld, true);
        _l1.makeSilent(_l2.currZoom_mc.currZoomBg_mc, true);
        _l1.addAccProp(_l2.currZoom_mc.currZoom_txt, _l3.ZOOM, "Enter the numeric zoom percentage level and hit enter.");
        _l1.addAccProp(_l2.fitPage_mc, _l3.FIT_PAGE, "This button will refit the document so that only the current page will be visible in the current view.");
        _l1.addAccProp(_l2.fitWidth_mc, _l3.FIT_WIDTH, "This button will refit the document by maximizing the width of the current page in the current view.");
        _l1.makeSilent(_l2.dividePager_mc, true);
        _l1.makeSilent(_l2.currPg_mc.currPgBg_mc, true);
        _l1.addAccProp(_l2.currPg_mc.currPg_txt, _l3.CURR_PAGE, "");
        _l1.makeSilent(_l2.numPgs_txt, true);
        _l1.addAccProp(_l2.prevNext_mc.prevPg_mc, _l3.PREV_PAGE, "");
        _l1.addAccProp(_l2.prevNext_mc.nextPg_mc, _l3.NEXT_PAGE, "");
        _l1.makeSilent(_l2.dividePrint_mc, true);
        _l1.addAccProp(_l2.print_mc, _l3.PRINT, "");
        _l1.addAccProp(_l2.hiddenToolsBtn_mc, _l3.OVERFLOW, "This button will reveal the tools that are hidden due to the resized view.");
        _l1.makeSilent(_l1.m_mainMC.hiddenToolsList_mc, true);
        _l1.makeSilent(_l1.m_mainMC.hiddneToolsList_mc.list_mc, true);
        _l1.makeSilent(_l2.popup_mc, true);
        toolbar_mc.accessible_mc.prevPg_mc.controller = _l1;
        toolbar_mc.accessible_mc.prevPg_mc.onRelease = function ()
        {
            this.controller.prevPageButton();
        };
        toolbar_mc.accessible_mc.nextPg_mc.controller = _l1;
        toolbar_mc.accessible_mc.nextPg_mc.onRelease = function ()
        {
            this.controller.nextPageButton();
        };
        _l1.makeMCHiddenAccButton(toolbar_mc.accessible_mc.prevPg_mc, "AccPrevPage");
        _l1.makeMCHiddenAccButton(toolbar_mc.accessible_mc.nextPg_mc, "AccNextPage");
        _l1.setMCHiddenAccButtonAvailable(toolbar_mc.accessible_mc.prevPg_mc, false);
        var document_mc = _l1.m_mainMC.document_mc;
        _l1.addAccProp(document_mc, _l3.CONTENT, "");
        _l1.makeSilent(document_mc.bg_mc, true);
        _l1.makeSilent(document_mc.x_sb, true);
        _l1.makeSilent(document_mc.y_sb, true);
        _l1.makeSilent(document_mc.corner_mc, true);
        Accessibility.updateProperties();
        if (Accessibility.isActive())
        {
            _l1.zoomToPageFit();
        } // end if
    } // End of the function
    function hyperlinksTabEnabled(pageIdx, enable)
    {
        var accInfo = eval("fpAltTextMap" + pageIdx);
        if (accInfo != null)
        {
            var page_mc = this.m_documentView.getNthPage(pageIdx);
            for (var instanceName in accInfo)
            {
                if (instanceName.indexOf("link") > -1)
                {
                    var mc = page_mc.rawPage_mc[instanceName];
                    if (mc != null)
                    {
                        mc.tabEnabled = enable;
                    } // end if
                } // end if
            } // end of for...in
        } // end if
    } // End of the function
    function activateHyperlinks(pageIdx)
    {
        var _l1 = this;
        if (pageIdx != _l1.m_currentPage)
        {
            _l1.hyperlinksTabEnabled(_l1.m_currentPage, false);
            _l1.hyperlinksTabEnabled(pageIdx, true);
        } // end if
    } // End of the function
    function makeAllPagesAccessible()
    {
        var listSize = this.m_accSilentList.length;
        var _l3 = 0;
        while (_l3 < listSize)
        {
            var _l2 = this.m_accSilentList.shift();
            var _l1 = this.m_documentView.getNthPage(_l2).rawPage_mc;
            _l1.tabEnabled = false;
            this.setRawPageTabIndex(_l1, _l2);
            _l1._accProps.forceSimple = false;
            ++_l3;
        } // end while
        return (listSize > 0);
    } // End of the function
    function makePageNotAccessible(pageIdx)
    {
        var _l2 = pageIdx;
        var _l3 = this;
        _l3.m_accSilentList.push(_l2);
        var _l1 = _l3.m_documentView.getNthPage(_l2).rawPage_mc;
        _l1.tabEnabled = false;
        _l3.setRawPageTabIndex(_l1, _l2);
        _l1._accProps.forceSimple = true;
    } // End of the function
    function accSilentPageBehindToolbar(pageIdx)
    {
        var rawPage_mc;
        var _l3 = pageIdx <= 1 ? (true) : (false);
        var _l1 = pageIdx - 1;
        var toolbarBounds = this.m_mainMC.toolbar_mc.getBounds(_root);
        var updateAccessibility = this.makeAllPagesAccessible();
        while (!_l3 && _l1 > 0)
        {
            rawPage_mc = this.m_documentView.getNthPage(_l1).rawPage_mc;
            var _l2 = rawPage_mc.getBounds(_root);
            if (_l2.yMax < toolbarBounds.yMin)
            {
                _l3 = true;
            }
            else if (_l2.yMax <= toolbarBounds.yMax)
            {
                this.makePageNotAccessible(_l1);
                updateAccessibility = true;
            } // end if
            --_l1;
        } // end while
        if (updateAccessibility)
        {
            Accessibility.updateProperties();
        } // end if
    } // End of the function
    function findBookmark(n, a)
    {
        var _l2 = a;
        var _l3 = n;
        for (var i in _l2)
        {
            var _l1 = _l2[i];
            if (_l1.publicName_str == _l3)
            {
                return (_l1);
            } // end if
            _l1 = this.findBookmark(_l3, _l1.subBookmarks_array);
            if (_l1 != null)
            {
                return (_l1);
            } // end if
        } // end of for...in
        return (null);
    } // End of the function
    function updateCurrentPage(pageNum_i)
    {
        this.m_currentPage = pageNum_i;
    } // End of the function
    function getNumPages()
    {
        return (this.m_numPages);
    } // End of the function
    function goToAnchor(anchor_o)
    {
        var _l1 = anchor_o;
        if (_l1)
        {
            this.m_currentPage = _l1.pageNum_i;
            this.m_documentView.goToAnchor(_l1);
        } // end if
    } // End of the function
    function goToNamedAnchor(anchorname)
    {
        var _l1 = this;
        if (_l1.m_mainMC.fpAnchors_o === undefined)
        {
        }
        else
        {
            _l1.goToAnchor(_l1.m_mainMC.fpAnchors_o[anchorname]);
        } // end if
    } // End of the function
    function getConfigString(s)
    {
        return (this.m_mainMC[s]);
    } // End of the function
    function makeSilent(pmc, silent)
    {
        var _l1 = pmc;
        if (_l1._accProps == null)
        {
            _l1._accProps = new Object();
        } // end if
        _l1._accProps.silent = silent;
    } // End of the function
    function addAccProp(pmc, name, desc)
    {
        var _l1 = pmc;
        if (_l1._accProps == null)
        {
            _l1._accProps = new Object();
        } // end if
        if (name.length > 0)
        {
            _l1._accProps.name = name;
        } // end if
        if (desc.length > 0)
        {
            _l1._accProps.description = desc;
        } // end if
    } // End of the function
    function makeMCAccessibleImage(pmc, desc)
    {
        var _l1 = pmc;
        this.makeSilent(_l1, false);
        _l1.tabEnabled = false;
        _l1._accProps.name = "Image";
        _l1._accProps.description = desc;
    } // End of the function
    function makeMCAccessibleHyperlink(pmc, link)
    {
        var _l1 = pmc;
        var _l3 = this;
        _l3.makeSilent(_l1, false);
        _l1.tabEnabled = false;
        _l1._focusrect = false;
        _l1._accProps.name = link;
        _l1._accImpl = new FPUI.AccObject(FPUI.AccObject.ROLE_SYSTEM_LINK);
        _l1.tabChildren = false;
        _l1.m_mainView = _l3;
        var mc = _l1.createEmptyMovieClip("focus_mc", 1);
        var _l2 = _l1.getBounds();
        mc.lineStyle(1, FPUI.Component.kHiliteColor, 40);
        mc.moveTo(_l2.xMin, _l2.yMin);
        mc.lineTo(_l2.xMax, _l2.yMin);
        mc.lineTo(_l2.xMax, _l2.yMax);
        mc.lineTo(_l2.xMin, _l2.yMax);
        mc.lineTo(_l2.xMin, _l2.yMin);
        mc._visible = false;
        _l1.onRelease = function ()
        {
            if (this.m_mainView.getCurrentTool() == "pan")
            {
                this.m_mainView.goToLinkTarget(link);
            } // end if
        };
        _l1.onRollOver = function ()
        {
            var _l2 = this;
            var _l1 = _l2.m_mainView.getCurrentTool();
            if (_l1 != "pan")
            {
                _l2.m_mainView.setCursor(_l2.m_mainView.getCursorFocus(), _l1);
            } // end if
        };
        _l1.onComponentSetFocus = function ()
        {
            this.focus_mc._visible = true;
        };
        _l1.onComponentKillFocus = function ()
        {
            this.focus_mc._visible = false;
        };
        _l1.onKeyDown = function ()
        {
            if (Key.getCode() == 13)
            {
                this.m_mainView.goToLinkTarget(link);
            } // end if
        };
    } // End of the function
    function makeMCHiddenAccButton(pmc, name, actionMC)
    {
        var _l1 = pmc;
        this.makeSilent(_l1, false);
        this.addAccProp(_l1, name, "");
        _l1.tabEnabled = false;
        _l1._accImpl = new FPUI.AccObject(FPUI.AccObject.ROLE_SYSTEM_PUSHBUTTON);
        _l1._accImpl.set_accState(FPUI.AccObject.STATE_SYSTEM_INVISIBLE, true);
        _l1._accImpl.set_accDefaultAction("Press", _l1, "onRelease");
        _l1.lineStyle(1, 16777215, 0);
        _l1.moveTo(0, 0);
        _l1.lineTo(10, 0);
        _l1.lineTo(10, 10);
        _l1.lineTo(0, 10);
        _l1.lineTo(0, 0);
        _l1._visible = true;
    } // End of the function
    function setMCHiddenAccButtonAvailable(pmc, available)
    {
        pmc._accImpl.set_accState(FPUI.AccObject.STATE_SYSTEM_UNAVAILABLE, !available);
    } // End of the function
    function setRawPageTabIndex(rawPage_mc, index)
    {
        rawPage_mc.tabIndex = this.m_nextTabIndex + index % 10;
    } // End of the function
    function loadPages()
    {
        var i = this.m_numPagesLoaded + 1;
        while (i <= this.m_numPages)
        {
            var page_mc = this.m_documentView.getNthPage(i);
            if (page_mc.rawPage_mc == undefined)
            {
                var rawPage_mc = page_mc.attachMovie("page" + i, "rawPage_mc", 10);
                if (rawPage_mc != undefined)
                {
                    rawPage_mc.tabEnabled = false;
                    rawPage_mc._accProps = new Object();
                    rawPage_mc._accProps.name = "";
                    this.setRawPageTabIndex(rawPage_mc, i);
                    Accessibility.updateProperties();
                    var fpcontent_mc = rawPage_mc;
                    if (rawPage_mc.fpcontent_mc != undefined)
                    {
                        fpcontent_mc = rawPage_mc.fpcontent_mc;
                    } // end if
                    page_mc.fpcontent_mc = fpcontent_mc;
                    page_mc.msg_mc.removeMovieClip();
                    var factor = this.getDocDpiToScreenDpiFactor() * 20;
                    rawPage_mc._width = rawPage_mc._width * factor;
                    rawPage_mc._height = rawPage_mc._height * factor;
                    fpcontent_mc.fpdoc_mc = this.m_mainMC;
                    if (fpcontent_mc != null && fpcontent_mc.getTextSnapshot != null)
                    {
                        fpcontent_mc.textSnapshot_ts = null;
                        fpcontent_mc.getTS = function (allocateIfNeeded_b)
                        {
                            var _l1 = this;
                            if (_l1.textSnapshot_ts == null && allocateIfNeeded_b)
                            {
                                _l1.textSnapshot_ts = _l1.getTextSnapshot();
                            } // end if
                            return (_l1.textSnapshot_ts);
                        };
                        fpcontent_mc.freeTS = function ()
                        {
                            delete this.textSnapshot_ts;
                        };
                    } // end if
                    var accInfo = eval("fpAltTextMap" + i);
                    if (accInfo != null)
                    {
                        for (var instanceName in accInfo)
                        {
                            var mc = rawPage_mc[instanceName];
                            if (mc != null)
                            {
                                if (instanceName.indexOf("acc") > -1)
                                {
                                    this.makeMCAccessibleImage(mc, accInfo[instanceName]);
                                }
                                else if (instanceName.indexOf("link") > -1)
                                {
                                    this.makeMCAccessibleHyperlink(mc, accInfo[instanceName]);
                                } // end if
                                var pmc = mc._parent;
                                while (pmc != null)
                                {
                                    this.makeSilent(pmc, false);
                                    pmc = pmc._parent;
                                } // end while
                            } // end if
                        } // end of for...in
                        Accessibility.updateProperties();
                    } // end if
                    if (i <= 2)
                    {
                        this.onResize();
                    } // end if
                    if (i == this.getNumberOfPages())
                    {
                        this.hyperlinksTabEnabled(1, true);
                        Accessibility.updateProperties();
                    } // end if
                    if (this.m_numPagesLoaded < i)
                    {
                        this.m_numPagesLoaded = i;
                    } // end if
                } // end if
            } // end if
            ++i;
        } // end while
    } // End of the function
    function setCursorFocus(mc)
    {
        this.m_cursorFocus = mc;
    } // End of the function
    function getCursorFocus()
    {
        return (this.m_cursorFocus);
    } // End of the function
    function setCursor(mc, cursorName)
    {
        var _l1 = this;
        if (mc != _l1.m_cursorFocus)
        {
        }
        else
        {
            var _l2 = _l1.m_mainMC.cursors_mc[cursorName];
            if (_l2 === undefined)
            {
                _l2 = null;
            } // end if
            if (_l1.m_currentCursorMC != _l2)
            {
                if (_l1.m_currentCursorMC == null)
                {
                    _l1.m_currentCursorMC = _l2;
                    _l1.showCursor();
                }
                else
                {
                    _l1.m_currentCursorMC._visible = false;
                    if (_l2 == null)
                    {
                        _l1.hideCursor();
                    } // end if
                    _l1.m_currentCursorMC = _l2;
                } // end if
                _l1.updateCursor();
            } // end if
        } // end if
    } // End of the function
    function showCursor()
    {
        var _l1 = this;
        if (_l1.m_currentCursorMC)
        {
            Mouse.hide();
            ++_l1.m_numMouseHides;
            _l1.updateCursor();
        } // end if
    } // End of the function
    function updateCursor()
    {
        var _l1 = this;
        if (_l1.m_currentCursorMC)
        {
            _l1.m_currentCursorMC._visible = _l1.m_numMouseHides > 0;
            _l1.m_currentCursorMC._y = _l1.m_currentCursorMC._parent._ymouse;
            _l1.m_currentCursorMC._x = _l1.m_currentCursorMC._parent._xmouse;
        } // end if
    } // End of the function
    function hideCursor()
    {
        var _l1 = this;
        if (_l1.m_currentCursorMC)
        {
            Mouse.show();
            --_l1.m_numMouseHides;
            _l1.updateCursor();
        } // end if
    } // End of the function
    function cleanupCursor()
    {
        var _l1 = this;
        while (_l1.m_numMouseHides > 0)
        {
            Mouse.show();
            --_l1.m_numMouseHides;
        } // end while
    } // End of the function
    function showMessage(s, mc)
    {
        var _l2 = this;
        var _l3 = false;
        var _l1 = _l2.m_mainMC.message_mc;
        _l1.clear();
        _l1.addItem("", s, "");
        _l1.setListVisible(s != "");
        if (mc != null)
        {
            _l1._x = Math.round(mc.getBounds(_l2.m_mainMC).xMin);
            _l3 = _l1._visible && _l1.getBounds(_l2.m_mainMC).xMax > _l2.m_mainMC.document_mc.bg_mc.getBounds(_l2.m_mainMC).xMax;
        } // end if
        return (_l3);
    } // End of the function
    function zoomTo(percent)
    {
        var _l1 = this;
        var _l2 = percent;
        var _l3 = _l1.m_currentScale;
        _l1.m_currentScale = FlashPaper.Utils.clamp(FlashPaper.MainView.ZOOM_MIN, _l2, FlashPaper.MainView.ZOOM_MAX);
        _l1.broadcastMessage("internal_onZoom", _l1.m_currentScale);
        if (_l3 != _l2)
        {
            _l1.broadcastMessage("onZoomChanged", _l2);
            _l1.m_documentView.delayedBroadcast("onVisibleAreaChanged", true);
        } // end if
    } // End of the function
    function zoomToNumber(percent_i)
    {
        this.m_viewMode = "zoom";
        this.zoomTo(percent_i);
    } // End of the function
    function zoomIn()
    {
        this.zoomToNumber(Math.min(FlashPaper.MainView.ZOOM_MAX, this.m_currentScale + FlashPaper.MainView.KEY_ZOOM_DISTANCE));
    } // End of the function
    function zoomOut()
    {
        this.zoomToNumber(Math.max(FlashPaper.MainView.ZOOM_MIN, this.m_currentScale - FlashPaper.MainView.KEY_ZOOM_DISTANCE));
    } // End of the function
    function zoomToPageFit()
    {
        var _l1 = this;
        var _l2 = _l1.getCurrentPage();
        _l1.m_viewMode = "page";
        _l1.zoomTo(_l1.m_pageFitScale);
        _l1.setCurrentPage(_l2);
    } // End of the function
    function zoomToWidthFit()
    {
        var _l1 = this;
        _l1.m_viewMode = "width";
        _l1.zoomTo(_l1.m_pageWidthScale);
    } // End of the function
    function getViewMode()
    {
        return (this.m_viewMode);
    } // End of the function
    function getCurrentScaleFraction()
    {
        return (this.m_currentScale / 100);
    } // End of the function
    function getBoundsInMainViewCoords(mc)
    {
        return (mc.getBounds(this.m_mainMC));
    } // End of the function
    function getMouseX()
    {
        return (this.m_mainMC._xmouse);
    } // End of the function
    function getMouseY()
    {
        return (this.m_mainMC._ymouse);
    } // End of the function
    function getPageFitScale()
    {
        return (this.m_pageFitScale);
    } // End of the function
    function getPageWidthScale()
    {
        return (this.m_pageWidthScale);
    } // End of the function
    function getIsHandheld()
    {
        return (this.m_isHandheld);
    } // End of the function
    function getDocViewWidth()
    {
        var _l1 = this;
        return (_l1.getWidth() - _l1.getSidebarWidth() - _l1.getDividerWidth());
    } // End of the function
    function getDocViewHeight()
    {
        return (this.getHeight() - this.m_documentView._y);
    } // End of the function
    function getDividerWidth()
    {
        var _l1 = this.m_mainMC.divider_mc;
        return (_l1._visible ? (_l1._width) : (0));
    } // End of the function
    function onKeyDown()
    {
        var _l1 = this;
        _l1.showMessage("", null);
        var _l3 = _l1.m_zoomingEnabled;
        var focusStr = Selection.getFocus();
        if (focusStr != null)
        {
            var s = targetPath(_l1.m_mainMC);
            if (focusStr.substr(0, s.length) != s)
            {
                
            } // end if
            _l3 = false;
        } // end if
        var _l2 = Key.getCode();
        if (_l2 == 13)
        {
            if (!_l1.handleEnterKey())
            {
                _l1.m_documentView.keyDown(_l2);
            } // end if
        }
        else
        {
            var char_s = String.fromCharCode(Key.getAscii()).toLowerCase();
            var prevNext_mc = _l1.m_mainMC.toolbar_mc.controls_mc.prevNext_mc;
            var ctrl = Key.isDown(17);
            if (ctrl && Key.isDown(34))
            {
                _l1[prevNext_mc.nextPg_mc.m_clickHandler]();
                Accessibility.updateProperties();
            }
            else if (ctrl && Key.isDown(33))
            {
                _l1[prevNext_mc.prevPg_mc.m_clickHandler]();
                Accessibility.updateProperties();
            }
            else if (_l2 == 17)
            {
                if (!_l1.m_ctrlKeyMonitorIntervalID)
                {
                    _l1.m_copied = false;
                    _l1.m_ctrlKeyMonitorIntervalID = setInterval(_l1, "ctrlKeyMonitor", 100);
                } // end if
            }
            else if (_l2 == 189 || _l2 == 109)
            {
                if (_l3)
                {
                    _l1.zoomOut();
                } // end if
            }
            else if (_l2 == 107 || Key.isDown(16) && Key.isDown(187))
            {
                if (_l3)
                {
                    _l1.zoomIn();
                } // end if
            }
            else if (char_s == "p")
            {
                if (_l3)
                {
                    _l1.zoomToPageFit();
                } // end if
            }
            else if (char_s == "w")
            {
                if (_l3)
                {
                    _l1.zoomToWidthFit();
                } // end if
            }
            else
            {
                _l1.m_documentView.keyDown(_l2);
            } // end if
        } // end if
    } // End of the function
    function copySelection()
    {
        var _l1 = this;
        if (_l1.getCurrentTool() != "select")
        {
        }
        else if (_l1.m_mainMC.toolbar_mc.controls_mc.selectTool_mc.fp_hidden)
        {
        }
        else
        {
            System.setClipboard(_l1.m_documentView.getSelectedText());
        } // end if
    } // End of the function
    function onKeyUp()
    {
        var _l1 = this;
        if (Selection.getFocus() == null)
        {
            var _l2 = Key.getCode();
            if (_l2 == 67 && Key.isDown(17) || _l2 == 17 && Key.isDown(67))
            {
                if (!_l1.m_copied)
                {
                    _l1.copySelection();
                    _l1.m_copied = true;
                } // end if
                
            } // end if
            if (_l2 == 17)
            {
                clearInterval(_l1.m_ctrlKeyMonitorIntervalID);
                _l1.m_ctrlKeyMonitorIntervalID = 0;
                _l1.m_copied = false;
            } // end if
        } // end if
    } // End of the function
    function ctrlKeyMonitor()
    {
        var _l1 = this;
        if (Key.isDown(67))
        {
            if (!_l1.m_copied)
            {
                _l1.copySelection();
                _l1.m_copied = true;
            } // end if
        }
        else if (_l1.m_copied)
        {
            _l1.m_copied = false;
        } // end if
    } // End of the function
    function handleEnterKey()
    {
        var _l2 = this;
        var controls_mc = _l2.m_mainMC.toolbar_mc.controls_mc;
        var currPg_txt = controls_mc.currPg_mc.currPg_txt;
        var _l3 = controls_mc.currZoom_mc.currZoom_txt;
        var find_txt = controls_mc.find_mc.find_txt;
        var _l1;
        var focusStr = Selection.getFocus();
        if (focusStr == targetPath(currPg_txt))
        {
            _l1 = parseInt(currPg_txt.text);
            if (isNaN(_l1))
            {
                currPg_txt.text = _l2.getCurrentPage();
            }
            else
            {
                _l2.setCurrentPage(_l1);
            } // end if
            Selection.setFocus(null);
            return (true);
        }
        else if (focusStr == targetPath(_l3))
        {
            _l1 = parseInt(_l3.text);
            if (isNaN(_l1))
            {
                _l3.text = Math.round(_l2.m_currentScale) + "%";
            }
            else
            {
                _l2.zoomToNumber(_l1);
            } // end if
            Selection.setFocus(null);
            return (true);
        }
        else if (focusStr == targetPath(find_txt))
        {
            _l2.findTextButton();
            return (true);
            
        }
        else
        {
            return (false);
        } // end if
    } // End of the function
    function onResize2()
    {
        this.onResize();
        this.onResize();
    } // End of the function
    function onResize()
    {
        var _l1 = this;
        var _l2 = _l1.m_toolbarView.getHeight() - 3;
        var _l3 = _l1.m_mainMC.tree_mc;
        _l3._x = 0;
        _l3._y = _l2;
        _l1.m_dividerView._x = _l1.getSidebarWidth();
        _l1.m_dividerView._y = _l2;
        _l1.m_documentView._x = _l1.getSidebarWidth() + _l1.getDividerWidth();
        _l1.m_documentView._y = _l2;
        _l1.broadcastMessage("onResize");
        _l1.m_pageWidthScale = _l1.m_documentView.calcPageWidthScale();
        _l1.m_pageFitScale = _l1.m_documentView.calcPageFitScale();
        if (_l1.m_viewMode == "width")
        {
            _l1.zoomToWidthFit();
        }
        else if (_l1.m_viewMode == "page")
        {
            _l1.zoomToPageFit();
        }
        else
        {
            _l1.zoomToNumber(_l1.m_currentScale);
        } // end if
        _l1.m_documentView.rebuildMask();
        _l1.showMessage("", null);
    } // End of the function
    function onPageMayHaveChanged()
    {
        var _l1 = this;
        if (_l1.m_lastPageChanged != _l1.m_currentPage)
        {
            _l1.m_lastPageChanged = _l1.m_currentPage;
            _l1.broadcastMessage("onPageChanged", _l1.m_lastPageChanged);
            _l1.m_documentView.delayedBroadcast("onVisibleAreaChanged", true);
        } // end if
    } // End of the function
    function getScrolledPage()
    {
        return (this.m_documentView.getScrolledPage(true));
    } // End of the function
    function getWidth()
    {
        return (Stage.width);
    } // End of the function
    function getHeight()
    {
        return (Stage.height);
    } // End of the function
    function getBookmarksArray()
    {
        return (this.m_mainMC.fpBookmarks_array);
    } // End of the function
    function getDocDpiToScreenDpiFactor()
    {
        return (this.m_docDpiToScreenDpiFactor);
    } // End of the function
    function getDocumentWidth()
    {
        return (this.m_mainMC.documentWidth);
    } // End of the function
    function getDocumentHeight()
    {
        return (this.m_mainMC.documentHeight);
    } // End of the function
    function setForcedWidthAndHeight(w, h)
    {
        var _l1 = this;
        _l1.m_forceWidth = w;
        _l1.m_forceHeight = h;
        _l1.getWidth = function ()
        {
            return (this.m_forceWidth);
        };
        _l1.getHeight = function ()
        {
            return (this.m_forceHeight);
        };
        _l1.m_documentView.rebuildMask();
    } // End of the function
    function popUpWindowButton()
    {
        var _l1 = _url;
        _l1 = FlashPaper.Utils.replaceInString(_l1, "\\", "\\\\");
        _l1 = escape(_l1);
        getURL("javascript:window.open(\"" + _l1 + "\", \"fpdoc\").focus();", "");
    } // End of the function
    function brandButton(_mc)
    {
        var _l1 = this.getLanguageObject();
        getURL(_l1.GOURL, "_blank");
    } // End of the function
    function findTextButton()
    {
        this.findNext();
    } // End of the function
    function fitWidthButton()
    {
        this.zoomToWidthFit();
    } // End of the function
    function fitPageButton()
    {
        this.zoomToPageFit();
    } // End of the function
    function printButton()
    {
        this.printTheDocument();
    } // End of the function
    function panButton(mc)
    {
        this.setCurrentTool("pan");
    } // End of the function
    function selectButton(mc)
    {
        var _l1 = this;
        if (!_l1.m_scrollingEnabled && _l1.getCurrentTool() == "select")
        {
            _l1.setCurrentTool("");
        }
        else
        {
            _l1.setCurrentTool("select");
        } // end if
    } // End of the function
    function prevPageButton()
    {
        var _l1 = this;
        if (_l1.getCurrentPage() > 1)
        {
            _l1.setCurrentPage(_l1.m_documentView.getScrolledPage(false) - 1);
        } // end if
    } // End of the function
    function nextPageButton()
    {
        var _l1 = this;
        if (_l1.getCurrentPage() < _l1.getNumPages())
        {
            _l1.setCurrentPage(_l1.m_documentView.getScrolledPage(true) + 1);
        } // end if
    } // End of the function
    function dropdownButton()
    {
        Selection.setFocus(null);
        this.m_mainMC.hiddenToolsList_mc.onButtonRelease();
    } // End of the function
    function broadcastMessage(msg)
    {
    } // End of the function
    function addListener(listener)
    {
    } // End of the function
    function removeListener(listener)
    {
    } // End of the function
    function getViewerType()
    {
        return ("Macromedia FlashPaper Default Viewer");
    } // End of the function
    function getViewerVersion()
    {
        return (218);
    } // End of the function
    function getCurrentPage()
    {
        return (this.m_currentPage);
    } // End of the function
    function setCurrentPage(pageNum_i)
    {
        var _l1 = this;
        var _l2 = FlashPaper.Utils.clamp(1, pageNum_i, _l1.m_numPages);
        _l1.activateHyperlinks(_l2);
        _l1.m_currentPage = _l2;
        _l1.m_documentView.setPage(_l1.m_currentPage);
        _l1.accSilentPageBehindToolbar(_l1.m_currentPage);
    } // End of the function
    function getNumberOfPages()
    {
        return (this.m_mainMC.totalPages);
    } // End of the function
    function getLoadedPages()
    {
        return (this.m_numPagesLoaded);
    } // End of the function
    function showUIElement(part, show)
    {
        var _l3 = this;
        var _l1 = _l3.m_mainMC.toolbar_mc.controls_mc;
        var _l2 = !show;
        switch (part)
        {
            case "PrevNext":
            {
                _l1.prevNext_mc.fp_hidden = _l2;
                _l1.currPg_mc.currPg_txt.selectable = show;
                break;
            } 
            case "Print":
            {
                _l1.dividePrint_mc.fp_hidden = _l2;
                _l1.print_mc.fp_hidden = _l2;
                break;
            } 
            case "Tool":
            {
                _l1.panTool_mc.fp_hidden = _l2;
                _l1.selectTool_mc.fp_hidden = _l2;
                break;
            } 
            case "Zoom":
            {
                _l1.currZoom_mc.fp_hidden = _l2;
                _l1.fitPage_mc.fp_hidden = _l2;
                _l1.fitWidth_mc.fp_hidden = _l2;
                _l1.zoom_sld.fp_hidden = _l2;
                _l1.divideZoom_mc.fp_hidden = _l2;
                break;
            } 
            case "Find":
            {
                _l1.find_mc.fp_hidden = _l2;
                _l1.divideTools_mc.fp_hidden = _l2;
                break;
            } 
            case "Pop":
            {
                _l1.popup_mc.fp_hidden = _l2;
                break;
            } 
            case "Page":
            {
                _l1.currPg_mc.fp_hidden = _l2;
                _l1.numPgs_txt.fp_hidden = _l2;
                _l1.dividePager_mc.fp_hidden = _l2;
                break;
            } 
            case "Sidebar":
            {
                if (_l3.m_mainMC.fpBookmarks_array)
                {
                    _l3.m_mainMC.divider_mc._visible = show;
                    _l3.m_mainMC.tree_mc._visible = show;
                } // end if
                break;
            } 
            case "Overflow":
            {
                _l1.hiddenToolsBtn_mc.fp_hidden = _l2;
                break;
            } 
            case "ZoomKeys":
            {
                _l3.m_zoomingEnabled = show;
                break;
            } 
        } // End of switch
        _l3.onResize2();
    } // End of the function
    function printTheDocument()
    {
        var _l1 = this;
        if (_l1.m_mainMC.printClip_mc == undefined)
        {
            _l1.m_mainMC.attachMovie("pageList", "printClip_mc", 9999);
            _l1.m_mainMC.printClip_mc._visible = false;
        } // end if
        if (_l1.m_mainMC.printClip_mc == undefined)
        {
            return (false);
        } // end if
        var _l2 = _l1.m_mainMC.printClip_mc.bmovieIsOK !== undefined && _l1.m_mainMC.printClip_mc.bmovieIsOK == true;
        var _l3 = _l1.m_mainMC.printasbitmap !== undefined && _l1.m_mainMC.printasbitmap == true;
        if (_l3)
        {
            if (_l2)
            {
                getURL("printasbitmap:", _l1.m_mainMC.printClip_mc);
            }
            else
            {
                getURL("printasbitmap:#bframe", _l1.m_mainMC.printClip_mc);
            } // end if
        }
        else if (_l2)
        {
            getURL("print:", _l1.m_mainMC.printClip_mc);
        }
        else
        {
            getURL("print:#bframe", _l1.m_mainMC.printClip_mc);
        } // end if
        return (true);
    } // End of the function
    function setCurrentZoom(percent)
    {
        var _l1 = percent;
        var _l2 = this;
        if (_l1 == "width")
        {
            _l2.zoomToWidthFit();
        }
        else if (_l1 == "page")
        {
            _l2.zoomToPageFit();
        }
        else
        {
            _l2.zoomToNumber(Number(_l1));
        } // end if
    } // End of the function
    function getCurrentZoom()
    {
        return (this.m_currentScale);
    } // End of the function
    function setSize(w, h)
    {
        var _l1 = this;
        _l1.m_mainMC._xscale = _l1.m_mainMC._yscale = 100;
        _l1.setForcedWidthAndHeight(w, h);
        _l1.onResize2();
        _l1.m_mainMC._visible = true;
        return (true);
    } // End of the function
    function goToLinkTarget(linktarget, window)
    {
        var _l1 = linktarget;
        if (_l1.substr(0, 7) == "anchor:")
        {
            this.goToNamedAnchor(_l1.substr(7));
        }
        else
        {
            getURL(_l1, window);
        } // end if
    } // End of the function
    function enableScrolling(flag)
    {
        var _l1 = this;
        var _l2 = flag;
        var _l3 = _l1.m_scrollingEnabled;
        if (_l1.m_scrollingEnabled != _l2)
        {
            _l1.m_scrollingEnabled = _l2;
            _l1.broadcastMessage("onEnableScrolling", _l2);
        } // end if
        return (_l3);
    } // End of the function
    function getCurrentTool()
    {
        return (this.m_documentView.getToolMode());
    } // End of the function
    function setCurrentTool(tool)
    {
        return (this.m_documentView.setToolMode(tool));
    } // End of the function
    function getTextSelectionRange()
    {
        return (this.m_documentView.getTextSelectionRange());
    } // End of the function
    function setTextSelectionRange(sel, skipBroadcast)
    {
        this.m_documentView.setTextSelectionRange(sel, skipBroadcast);
    } // End of the function
    function getSelectedText()
    {
        return (this.m_documentView.getSelectedText());
    } // End of the function
    function getSidebarWidth()
    {
        var _l1 = this;
        return (_l1.m_mainMC.tree_mc._visible ? (FlashPaper.Utils.clamp(0, _l1.m_treeWidth, _l1.getWidth() - _l1.m_documentView.getMinWidth())) : (0));
    } // End of the function
    function setSidebarWidth(w)
    {
        var _l1 = this;
        _l1.m_treeWidth = FlashPaper.Utils.clamp(0, w, _l1.getWidth() - _l1.m_documentView.getMinWidth());
        _l1.onResize();
    } // End of the function
    function getFindText()
    {
        return (this.m_mainMC.toolbar_mc.controls_mc.find_mc.find_txt.text);
    } // End of the function
    function setFindText(s)
    {
        this.m_mainMC.toolbar_mc.controls_mc.find_mc.find_txt.text = s;
    } // End of the function
    function findNext()
    {
        var found = true;
        var _l2 = this.getFindText();
        if (_l2.length > 0)
        {
            found = this.m_documentView.findText(_l2, false);
            if (!found)
            {
                var dot = "";
                var _l1 = this.getLanguageObject().NOT_FOUND;
                var _l3 = _l1.indexOf("%");
                if (_l3 != -1)
                {
                    _l1 = _l1.substring(0, _l3) + _l2 + dot + _l1.substring(_l3 + 1, _l1.length);
                } // end if
                if (!this.showMessage(_l1, this.m_mainMC.toolbar_mc.controls_mc.find_mc))
                {
                }
                else if (_l2.length == 0)
                {
                }
                else
                {
                    _l2 = _l2.substring(0, _l2.length - 1);
                    dot = "...";
                    
                } // end if
            } // end if
        } // end if
        if (found)
        {
            this.showMessage("", null);
        } // end if
        return (found);
    } // End of the function
    function getVisibleArea()
    {
        return (this.m_documentView.getVisibleArea());
    } // End of the function
    function setVisibleArea(area, skipBroadcast)
    {
        this.m_documentView.setVisibleArea(area, skipBroadcast);
    } // End of the function
    static var ZOOM_MIN = 10;
    static var ZOOM_MAX = 999;
    static var TREE_WIDTH = 200;
    static var KEY_ZOOM_DISTANCE = 5;
    var m_currentPage = 0;
    var m_numPages = 0;
    var m_numPagesLoaded = 0;
    var m_forceWidth = 0;
    var m_forceHeight = 0;
    var m_currentScale = 100;
    var m_pageFitScale = 100;
    var m_pageWidthScale = 100;
    var m_currentCursorMC = null;
    var m_numMouseHides = 0;
    var m_screenDPI = 0;
    var m_cursorFocus = null;
    var m_ctrlKeyMonitorIntervalID = 0;
    var m_copied = false;
    var m_nextTabIndex = 1;
    var m_lastPageChanged = -1;
    var m_scrollingEnabled = true;
    var m_zoomingEnabled = true;
    var m_accSilentList = null;
} // End of Class
