class FlashPaper.ToolbarView
{
    var m_mainView, m_toolbarMC, m_margin, m_mainMC;
    function ToolbarView(parentView_o, main_mc, popupEnabled)
    {
        var _l1 = this;
        _l1.m_mainMC = main_mc;
        _l1.m_toolbarMC = main_mc.toolbar_mc;
        _l1.m_mainView = parentView_o;
        _l1.m_margin = FlashPaper.ToolbarView.TOOLBAR_MARGIN;
        _l1.m_popupEnabled = popupEnabled;
        _l1.m_controlsHidden = new Array();
        _l1.m_toolbarMC.brandClip_mc.gotoLink_btn.tabEnabled = false;
        var _l2 = _l1.m_toolbarMC.controls_mc;
        if (_l1.m_mainView.getIsHandheld())
        {
            _l1.m_popupEnabled = false;
        } // end if
        _l2.print_mc.setEnabled(false);
        _l2.currPg_mc.currPg_txt.restrict = "0-9";
        _l2.currZoom_mc.currZoom_txt.restrict = "0-9%";
        _l2.find_mc.find_txt.restrict = "^\x1-\x1f";
        var hiddenTools = _l1.m_mainMC.hiddenToolsList_mc;
        hiddenTools.setButton(_l2.hiddenToolsBtn_mc);
        hiddenTools.setController(_l1.m_mainView);
        hiddenTools.setCursorManager(_l1.m_mainView);
        var _l3 = _l2.zoom_sld;
        _l3.setSliderProperties(FlashPaper.ToolbarView.SLIDER_MIN, FlashPaper.ToolbarView.SLIDER_MAX);
        _l3.setSnapThreshold(FlashPaper.ToolbarView.SLIDER_SNAP_THRESHOLD);
        _l3.setZoomKeyController(_l1.m_mainView);
        _l1.updateSliderSnapValues(_l3);
        if (_l1.m_toolbarMC.toolbarBg_mc._height != FlashPaper.ToolbarView.TOOLBAR_HEIGHT)
        {
            var toolbarScale_i = FlashPaper.ToolbarView.TOOLBAR_HEIGHT / _l1.m_toolbarMC.toolbarBg_mc._height * 100;
            _l1.m_toolbarMC.toolbarBg_mc._yscale = toolbarScale_i;
            _l2._yscale = _l2._xscale = toolbarScale_i;
            _l1.m_toolbarMC.brandClip_mc._xscale = _l1.m_toolbarMC.brandClip_mc._yscale = toolbarScale_i;
        } // end if
        if (!_l1.m_popupEnabled)
        {
            _l2.popup_mc._visible = false;
        } // end if
        _l1.m_toolbarMC.toolbarBg_mc._yscale = 100;
        _l1.m_toolbarMC.toolbarBg_mc._xscale = 100;
        _l1.onResize();
        _l1.m_mainView.addListener(_l1);
    } // End of the function
    function updateSliderSnapValues(zoom_sld)
    {
        var _l1 = FlashPaper.ToolbarView.SLIDER_SNAP_VALUES;
        _l1.unshift(this.m_mainView.getPageFitScale(), this.m_mainView.getPageWidthScale());
        zoom_sld.setSnapValues(_l1);
    } // End of the function
    function internal_onAddPage(width_i, height_i)
    {
        var _l2 = this.m_toolbarMC.controls_mc;
        var _l1 = this.m_mainView.getNumPages();
        _l2.numPgs_txt.text = "/" + _l1;
    } // End of the function
    function getHeight()
    {
        return (this.m_toolbarMC.toolbarBg_mc._height);
    } // End of the function
    function onResize()
    {
        var _l1 = this;
        var _l2 = _l1.m_toolbarMC.controls_mc;
        var smallTextFormat = new TextFormat(FlashPaper.Utils.UIFONT, FlashPaper.Utils.UISMALLFONTSIZE, 0);
        _l2.numPgs_txt.setNewTextFormat(smallTextFormat);
        _l2.currPg_mc.currPg_txt.setNewTextFormat(smallTextFormat);
        _l2.currZoom_mc.currZoom_txt.setNewTextFormat(smallTextFormat);
        var find_mc = _l2.find_mc;
        find_mc.find_txt.setNewTextFormat(smallTextFormat);
        var toolbarBg_mc = _l1.m_toolbarMC.toolbarBg_mc;
        toolbarBg_mc.middle_mc._width = _l1.m_mainView.getWidth();
        toolbarBg_mc.right_mc._x = _l1.m_mainView.getWidth() - toolbarBg_mc.right_mc._width;
        var _l3 = 0;
        while (_l3 < FlashPaper.ToolbarView.TOOLBAR_ORDER.length)
        {
            var s = FlashPaper.ToolbarView.TOOLBAR_ORDER[_l3];
            _l2[FlashPaper.ToolbarView.TOOLBAR_ORDER[_l3]]._visible = true;
            ++_l3;
        } // end while
        _l2.hiddenToolsBtn_mc._visible = false;
        var hh = _l1.m_mainView.getIsHandheld();
        if (!_l1.m_popupEnabled || hh)
        {
            _l2.popup_mc._visible = false;
        } // end if
        if (hh)
        {
            _l2.print_mc._visible = false;
            _l2.dividePrint_mc._visible = false;
        } // end if
        if (_l1.m_toolbarMC.getTextSnapshot == null)
        {
            _l2.panTool_mc._visible = false;
            _l2.selectTool_mc._visible = false;
            _l2.divideTools_mc._visible = false;
            _l2.find_mc._visible = false;
            _l2.divideZoom_mc._visible = false;
        } // end if
        var np = _l1.m_mainView.getNumberOfPages();
        if (np <= 1)
        {
            _l2.dividePager_mc._visible = false;
            _l2.currPg_mc._visible = false;
            _l2.numPgs_txt._visible = false;
            _l2.prevNext_mc._visible = false;
            _l2.dividePager_mc._x = 0;
            _l2.currPg_mc._x = 0;
            _l2.numPgs_txt._x = 0;
            _l2.prevNext_mc._x = 0;
        } // end if
        var ctrlsWidth = _l1.stackItems();
        var brandClip_mc = _l1.m_toolbarMC.brandClip_mc;
        var availWidth = _l1.m_mainView.getWidth() - (brandClip_mc._x + brandClip_mc._width) - _l1.m_margin;
        var removeIdx = 0;
        var removeItem = true;
        var numControlsRemoved = 0;
        do
        {
            var s = FlashPaper.ToolbarView.TOOLBAR_PRIORITY[removeIdx];
            var remove_mc = _l2[s];
            if (remove_mc != undefined && ctrlsWidth > availWidth)
            {
                if (remove_mc._visible)
                {
                    remove_mc._visible = false;
                    if (!_l2.hiddenToolsBtn_mc.fp_hidden)
                    {
                        _l2.hiddenToolsBtn_mc._visible = true;
                    } // end if
                    ctrlsWidth = _l1.stackItems();
                    ++numControlsRemoved;
                    if (numControlsRemoved > _l1.m_controlsHidden.length)
                    {
                        _l1.addToHiddenList(s);
                        _l1.m_controlsHidden.push(s);
                    } // end if
                } // end if
            }
            else
            {
                removeItem = false;
            } // end if
            ++removeIdx;
        } while (removeItem == true)
        while (numControlsRemoved < _l1.m_controlsHidden.length)
        {
            _l1.removeFromHiddenList(_l1.m_controlsHidden[_l1.m_controlsHidden.length - 1]);
            _l1.m_controlsHidden.pop();
        } // end while
        var zoom_sld = _l2.zoom_sld;
        _l1.updateSliderSnapValues(zoom_sld);
        var hiddenTools = _l1.m_mainMC.hiddenToolsList_mc;
        hiddenTools.setListVisible(false);
    } // End of the function
    function stackItems()
    {
        var ctrls = this.m_toolbarMC.controls_mc;
        var stackWidth_i = 0;
        var xPos_i = ctrls._width;
        var _l2 = FlashPaper.ToolbarView.TOOLBAR_ORDER.length - 1;
        while (_l2 >= 0)
        {
            var _l3 = FlashPaper.ToolbarView.TOOLBAR_ORDER[_l2];
            var _l1 = ctrls[_l3];
            if (_l1._visible && !_l1.fp_hidden)
            {
                xPos_i = xPos_i - _l1._width;
                _l1._x = Math.round(xPos_i);
                var spacing = _l3 == "numPgs_txt" ? (1) : (FlashPaper.ToolbarView.TOOLBAR_SPACING);
                xPos_i = xPos_i - spacing;
                stackWidth_i = stackWidth_i + (_l1._width + spacing);
            }
            else
            {
                _l1._visible = false;
                _l1._x = 0;
            } // end if
            --_l2;
        } // end while
        ctrls._x = Math.round(this.m_mainView.getWidth() - ctrls._width - this.m_margin);
        return (stackWidth_i);
    } // End of the function
    function internal_onZoom(percent)
    {
        var _l1 = this.m_toolbarMC.controls_mc;
        var _l3 = this.m_mainView.getViewMode();
        _l1.fitPage_mc.setActive(_l3 == "page");
        _l1.fitWidth_mc.setActive(_l3 == "width");
        _l1.currZoom_mc.currZoom_txt.text = Math.round(percent) + "%";
        var _l2 = _l1.zoom_sld;
        _l2.setChangeHandler(null);
        _l2.setValue(percent);
        _l2.setChangeHandler("zoomSelect", this);
    } // End of the function
    function zoomSelect(sld)
    {
        var _l2 = this.m_mainView.getIsHandheld();
        var _l1 = sld.getFocused();
        if (!_l2 && _l1 || _l2 && !_l1)
        {
            var _l3 = parseInt(sld.getValue());
            if (!isNaN(_l3))
            {
                this.m_mainView.setCurrentZoom(_l3);
            } // end if
        } // end if
    } // End of the function
    function internal_onScroll()
    {
        var _l2 = this;
        var pageNum_i = _l2.m_mainView.getScrolledPage();
        _l2.m_mainView.updateCurrentPage(pageNum_i);
        var ctrls = _l2.m_toolbarMC.controls_mc;
        ctrls.currPg_mc.currPg_txt.text = pageNum_i;
        var stateChanged = false;
        var _l3 = pageNum_i < _l2.m_mainView.getNumPages();
        var enablePrevPage = pageNum_i > 1;
        var _l1 = ctrls.prevNext_mc;
        if (_l1.nextPg_mc.getEnabled() != _l3)
        {
            _l1.nextPg_mc.setEnabled(_l3);
            _l1.nextPg_mc._accProps.silent = !_l3;
            _l2.m_mainView.setMCHiddenAccButtonAvailable(_l2.m_toolbarMC.accessible_mc.nextPg_mc, _l3);
            stateChanged = true;
        } // end if
        if (_l1.prevPg_mc.getEnabled() != enablePrevPage)
        {
            _l1.prevPg_mc.setEnabled(enablePrevPage);
            _l1.prevPg_mc._accProps.silent = !enablePrevPage;
            _l2.m_mainView.setMCHiddenAccButtonAvailable(_l2.m_toolbarMC.accessible_mc.prevPg_mc, enablePrevPage);
            stateChanged = true;
        } // end if
        if (stateChanged)
        {
            Accessibility.updateProperties();
        } // end if
    } // End of the function
    function internal_onDocumentLoaded()
    {
        this.m_toolbarMC.controls_mc.print_mc.setEnabled(true);
    } // End of the function
    function onToolChanged(newtool)
    {
        var _l1 = this.m_toolbarMC.controls_mc;
        _l1.panTool_mc.setActive(newtool == "pan");
        _l1.selectTool_mc.setActive(newtool == "select");
    } // End of the function
    function onEnableScrolling(flag)
    {
        this.m_toolbarMC.controls_mc.panTool_mc.setEnabled(flag);
    } // End of the function
    function addToHiddenList(mcInstanceName)
    {
        var ctrls = this.m_toolbarMC.controls_mc;
        var _l1 = ctrls[mcInstanceName];
        var _l3 = this.m_mainView.getLanguageObject();
        var _l2 = this.m_mainMC.hiddenToolsList_mc;
        if (mcInstanceName == "prevNext_mc")
        {
            _l2.addItem(_l1.prevPg_mc.m_iconName, _l3[_l1.prevPg_mc.m_localName], _l1.prevPg_mc.m_clickHandler);
            _l2.addItem(_l1.nextPg_mc.m_iconName, _l3[_l1.nextPg_mc.m_localName], _l1.nextPg_mc.m_clickHandler);
        }
        else if (mcInstanceName == "fitWidth_mc")
        {
            _l2.addDivider();
            _l2.addItem(_l1.m_iconName, _l3[_l1.m_localName], _l1.m_clickHandler);
        }
        else if (mcInstanceName == "fitPage_mc")
        {
            _l2.addItem(_l1.m_iconName, _l3[_l1.m_localName], _l1.m_clickHandler);
        }
        else if (mcInstanceName == "zoom_sld")
        {
            _l2.addDivider();
            _l2.addItem(FlashPaper.ToolbarView.ICON_ZOOM_IN, _l3.ZOOM_IN, "zoomIn");
            _l2.addItem(FlashPaper.ToolbarView.ICON_ZOOM_OUT, _l3.ZOOM_OUT, "zoomOut");
        }
        else if (mcInstanceName == "print_mc")
        {
            _l2.addDivider();
            _l2.addItem(_l1.m_iconName, _l3[_l1.m_localName], _l1.m_clickHandler);
        } // end if
    } // End of the function
    function removeFromHiddenList(mcInstanceName)
    {
        var _l2 = mcInstanceName;
        var _l1 = this.m_mainMC.hiddenToolsList_mc;
        if (_l2 == "print_mc")
        {
            _l1.removeItem();
            _l1.removeDivider();
        }
        else if (_l2 == "zoom_sld")
        {
            _l1.removeItem();
            _l1.removeItem();
            _l1.removeDivider();
        }
        else if (_l2 == "fitPage_mc")
        {
            _l1.removeItem();
        }
        else if (_l2 == "fitWidth_mc")
        {
            _l1.removeItem();
            _l1.removeDivider();
        }
        else if (_l2 == "prevNext_mc")
        {
            _l1.removeItem();
            _l1.removeItem();
        } // end if
    } // End of the function
    static var TOOLBAR_MARGIN = 3;
    static var TOOLBAR_HEIGHT = 31;
    static var TOOLBAR_SPACING = 3;
    static var SLIDER_MIN = 25;
    static var SLIDER_MAX = 250;
    static var SLIDER_SNAP_VALUES = [100];
    static var SLIDER_SNAP_THRESHOLD = 8;
    static var ICON_PREV_PAGE = "iconPrevPage";
    static var ICON_NEXT_PAGE = "iconNextPage";
    static var ICON_FIT_WIDTH = "iconFitWidth";
    static var ICON_FIT_PAGE = "iconFitPage";
    static var ICON_ZOOM_IN = "iconZoomIn";
    static var ICON_ZOOM_OUT = "iconZoomOut";
    static var ICON_PRINT = "iconPrint";
    static var TOOLBAR_ORDER = ["panTool_mc", "selectTool_mc", "divideTools_mc", "find_mc", "divideZoom_mc", "zoom_sld", "currZoom_mc", "fitPage_mc", "fitWidth_mc", "dividePager_mc", "currPg_mc", "numPgs_txt", "prevNext_mc", "dividePrint_mc", "print_mc", "popup_mc", "hiddenToolsBtn_mc"];
    static var TOOLBAR_PRIORITY = ["prevNext_mc", "fitWidth_mc", "fitPage_mc", "numPgs_txt", "currPg_mc", "dividePager_mc", "divideZoom_mc", "divideTools_mc", "currZoom_mc", "zoom_sld", "print_mc", "panTool_mc", "selectTool_mc", "dividePrint_mc", "find_mc"];
} // End of Class
